<?php
if ( ! defined( 'ABSPATH' ) ) {
    exit; // Exit if accessed directly.
}

function meeeksaas_admin_notice() {
    // Check if the notice has been dismissed (stored in transients for 7 days)
    if (get_transient('meeeksaas_admin_upgrade_notice_dismissed')) {
        return;
    }
	if (meeeksaasav3_get_env_license_type() != 'Regular License') {
        return;
	}

    ?>
    <div class="notice meeeksaas-notice is-dismissible">
        <img width="70" src="<?php echo esc_url(MEEEKSAAS_PLUGIN_URL.'assets/images/logo.png'); ?>" alt="<?php esc_attr_e('logo', 'meeeksaas'); ?>" />
        <h2><?php esc_html_e('Upgrade to Extended License to unlock:', 'meeeksaas'); ?></h2>
        <ul>
        	<li><?php esc_html_e('🎨 Get our Meeek WordPress theme for Free!', 'meeeksaas'); ?></li>
        	<li><?php esc_html_e('💰 Access to download the monetization tool to create pricing plans!', 'meeeksaas'); ?></li>
        	<li><?php esc_html_e('🚀 Fullscreen User Dashboard, Monetization / Paid Accounts, Payments, Refunds & more.', 'meeeksaas'); ?></li>
        	<li><?php esc_html_e('🔥 Supercharge your bio links platform with premium features.', 'meeeksaas'); ?></li>
        </ul>
        <a href="https://codecanyon.net/cart/configure_before_adding/46935773?license=extended&support=bundle_6month" target="_blank" class="button button-primary"target="_blank"><?php esc_html_e('Upgrade to Extended License!', 'meeeksaas'); ?></a>
    </div>

    <style>
		.meeeksaas-notice {
		    background: linear-gradient(to bottom left, #363636 40%, #000000 100%);
		    color: #fff;
		    padding: 40px;
		    border-left: 8px solid #C96CDF;
		}
        .meeeksaas-notice .notice-dismiss {
		    top: 5px;
		    right: 5px;
		    color: #787c82;
		    background: #fff;
		    border: 0 none;
		}
        .meeeksaas-notice li {
            font-size: 17px;
            font-weight: 300;
        }
		.meeeksaas-notice h2 {
		    margin-bottom: 30px;
		    color: #fff;
		    font-size: 24px;
		    margin-top: 20px;
		}
		.meeeksaas-notice .button-primary {
		    background: linear-gradient(to bottom left, #6426A1 50%, #C96CDF 100%);
		    border: 0 none;
		    color: #fff;
		    text-shadow: none;
		    padding: 9px 20px;
		    font-weight: 500;
		    font-size: 14px;
		    margin-top: 15px;
		    border-radius: 7px;
		}
        .meeeksaas-notice .button-primary:hover {
		    background: linear-gradient(to bottom left, #C96CDF 50%, #6426A1 100%);
            border-color: #e84118;
        }
    </style>

    <script>
        jQuery(document).ready(function($){
            $('.meeeksaas-notice').on('click', '.notice-dismiss', function(){
                $.post(ajaxurl, { action: 'meeeksaas_dismiss_notice' });
            });
        });
    </script>
    <?php
}
add_action('admin_notices', 'meeeksaas_admin_notice');


// Handle dismiss action via AJAX and store in transients
function meeeksaas_dismiss_notice() {
    set_transient('meeeksaas_admin_upgrade_notice_dismissed', true, 7 * DAY_IN_SECONDS);
    wp_die();
}
add_action('wp_ajax_meeeksaas_dismiss_notice', 'meeeksaas_dismiss_notice');