<?php
add_action( 'cmb2_admin_init', 'meeeksaas_settings_panel_options_metabox' );
/**
 * Hook in and register a metabox to handle a theme options page and adds a menu item.
 */
function meeeksaas_settings_panel_options_metabox() {

	$cmb = new_cmb2_box( array(
		'id'           => 'meeeksaas_settings',
		'title'        => esc_html__('General Settings', 'meeeksaas'),
		'description'  => esc_html__('Customize your general settings here.', 'meeeksaas'),
		'object_types' => array( 'options-page' ),
		'option_key'   => 'mt-saas-settings',
		'icon_url'     => 'dashicons-palmtree',
		'display_cb'   => 'meeeksaas_general_settings_page', // Override the options-page form output (CMB2_Hookup::options_page_output()).
	) );

	$cmb->add_field( array(
	    'name'    => esc_html__('Whitelabel Name', 'meeeksaas'),
	    'desc'    => esc_html__('Your business name to replace the Meeek branding', 'meeeksaas'),
	    'default' => '',
	    'id'      => 'meeeksaas_whitelabel_text',
	    'type'    => 'text',
	) );
	$cmb->add_field( array(
	    'name'    => esc_html__('Whitelabel Logo (Light Version)', 'meeeksaas'),
	    'desc'    => esc_html__('Replace the Meeek branding Logo with your logo. This is mostly used on User page edit bar.', 'meeeksaas'),
	    'id'      => 'meeeksaas_whitelabel_logo',
	    'type'    => 'file',
	    // Optional:
	    'options' => array(
	        'url' => false, // Hide the text input for the url
	    ),
	    'text'    => array(
	        'add_upload_file_text' => esc_html__('Upload Image', 'meeeksaas'), // Change upload button text. Default: "Add or Upload File"
	    ),
	    // query_args are passed to wp.media's library query.
	    'query_args' => array(
	        // 'type' => 'application/pdf', // Make library only display PDFs.
	        // Or only allow gif, jpg, or png images
	        'type' => array(
	            'image/gif',
	            'image/jpeg',
	            'image/png',
	        ),
	    ),
	    'preview_size' => 'full', // Image size to use when previewing in the admin.
	) );
	$cmb->add_field( array(
	    'name'    => esc_html__('Whitelabel Logo (Dark Version)', 'meeeksaas'),
	    'desc'    => esc_html__('Replace the Meeek branding Logo with your logo. This will be listed on public pages (footer brand logo + user dashboard sidebar)', 'meeeksaas'),
	    'id'      => 'meeeksaas_whitelabel_logo_dark',
	    'type'    => 'file',
	    // Optional:
	    'options' => array(
	        'url' => false, // Hide the text input for the url
	    ),
	    'text'    => array(
	        'add_upload_file_text' => esc_html__('Upload Image', 'meeeksaas'), // Change upload button text. Default: "Add or Upload File"
	    ),
	    // query_args are passed to wp.media's library query.
	    'query_args' => array(
	        // 'type' => 'application/pdf', // Make library only display PDFs.
	        // Or only allow gif, jpg, or png images
	        'type' => array(
	            'image/gif',
	            'image/jpeg',
	            'image/png',
	        ),
	    ),
	    'preview_size' => 'full', // Image size to use when previewing in the admin.
	) );
	$cmb->add_field( array(
	    'name'    => esc_html__('Whitelabel Logo Icon (Account Navigation)', 'meeeksaas'),
	    'desc'    => esc_html__('A logo icon for the fullscreen navigation menu', 'meeeksaas'),
	    'id'      => 'meeeksaas_logo_icon',
	    'type'    => 'file',
	    // Optional:
	    'options' => array(
	        'url' => false, // Hide the text input for the url
	    ),
	    'text'    => array(
	        'add_upload_file_text' => esc_html__('Upload Image', 'meeeksaas'), // Change upload button text. Default: "Add or Upload File"
	    ),
	    // query_args are passed to wp.media's library query.
	    'query_args' => array(
	        // 'type' => 'application/pdf', // Make library only display PDFs.
	        // Or only allow gif, jpg, or png images
	        'type' => array(
	            'image/gif',
	            'image/jpeg',
	            'image/png',
	        ),
	    ),
	    'preview_size' => 'full', // Image size to use when previewing in the admin.
	) );
	$cmb->add_field( array(
	    'name' => esc_html__('Logo Width', 'meeeksaas'),
	    'desc' => esc_html__('(In px). Frontend Logo Width', 'meeeksaas'),
	    'id' => 'meeeksaas_logo_width',
	    'default' => '80',
	    'type' => 'text_small'
	) );
	$cmb->add_field( array(
	    'name'    => esc_html__('Builder Preview Style', 'meeeksaas'),
	    'id'      => 'meeeksaas_builder_preview',
	    'type'    => 'radio_inline',
	    'options' => array(
	        'responsive' => __( 'Responsive', 'meeeksaas' ),
	        'mobile-frame'   => __( 'Mobile Frame', 'meeeksaas' ),
	    ),
	    'default' => 'responsive',
	) );

	// $cmb->add_field( array(
	//     'name' => esc_html__('Unlimited Links Benefit Limit', 'meeeksaas'),
	//     'desc' => esc_html__('The max number of links in a bio page a user can create when the Unlimited Links benefit is disabled on a plan.', 'meeeksaas'),
	//     'id' => 'meeeksaas_unlimited_links',
	//     'default' => '10',
	//     'type' => 'text_small'
	// ) );
	$cmb->add_field( array(
	    'name' => esc_html__('Sharing Panel', 'meeeksaas'),
	    'desc' => esc_html__('Show or Hide the Sharing panel across all of the public pages (Enabled by default)', 'meeeksaas'),
	    'id'   => 'meeeksaas_sharing',
	    'type' => 'checkbox',
	) );
	$cmb->add_field( array(
	    'name' => esc_html__('Home Link (Social Links)', 'meeeksaas'),
	    'desc' => esc_html__('Show a home website link before all the social links', 'meeeksaas'),
	    'id'   => 'meeeksaas_home_link',
	    'type' => 'checkbox',
	) );

	$cmb->add_field( array(
	    'name' => esc_html__('Splash Screen Loader', 'meeeksaas'),
	    'desc' => esc_html__('Enable a branded splash screen loader. If this option is enabled but the logos are not set, Meeek brand logo will be listed.', 'meeeksaas'),
	    'id'   => 'meeeksaas_splashscreen_status',
	    'type' => 'checkbox',
	) );
	$cmb->add_field( array(
	    'name'    => esc_html__('Splash Screen Logo', 'meeeksaas'),
	    'id'      => 'meeeksaas_splashscreen_logo',
	    'type'    => 'radio_inline',
	    'options' => array(
	        'light' => __( 'Light Logo', 'meeeksaas' ),
	        'dark'   => __( 'Dark Logo', 'meeeksaas' ),
	    ),
	    'default' => 'light',
		'attributes' => array(
			'data-conditional-id'    => 'meeeksaas_splashscreen_status',
			'data-conditional-value' => 'on',
		),
	) );
	$cmb->add_field( array(
	    'name'    => esc_html__('Splash Screen Background', 'meeeksaas'),
	    'id'      => 'meeeksaas_splashscreen_bg',
	    'type'    => 'colorpicker',
	    'default' => '#dddddd',
		'attributes' => array(
			'data-conditional-id'    => 'meeeksaas_splashscreen_status',
			'data-conditional-value' => 'on',
		),
	) );

	$cmb->add_field( array(
	    'name' => esc_html__('Free Accounts', 'meeeksaas'),
	    'desc' => esc_html__('Enable access to users with NO Subscriptions to build Bio Link Pages (benefits limited to what is selected below).', 'meeeksaas'),
	    'id'   => 'meeeksaas_user_trial_status',
	    'type' => 'checkbox',
	) );

	$all_benefits = array();
	if(function_exists('meeek_saas_benefits_list')){
		$all_benefits = meeek_saas_benefits_list();
	}else{
		$all_benefits = meeek_saas_benefits_list_free_accounts();
	}

	$cmb->add_field( array(
	    'name'    => esc_html__('Free Accounts Benefits', 'meeeksaas'),
	    'desc'    => esc_html__('Carefully select/unselect the benefits from this list. Any selected benefit will be applied for all the free accounts.', 'meeeksaas'),
	    'id'      => 'meeeksaas_user_trial_benefits',
	    'type'    => 'multicheck',
		'attributes' => array(
			'data-conditional-id'    => 'meeeksaas_user_trial_status',
			'data-conditional-value' => 'on',
		),
	    'options' => $all_benefits
	) );

	$cmb->add_field( array(
	    'name' => esc_html__('Free Accounts Pages Limit', 'meeeksaas'),
	    'desc' => esc_html__('How many unique pages can a free account holder create.', 'meeeksaas'),
	    'id' => 'meeeksaas_free_accounts_limit',
	    'default' => '3',
	    'type' => 'text_small',
		'attributes' => array(
			'data-conditional-id'    => 'meeeksaas_user_trial_status',
			'data-conditional-value' => 'on',
		),
	) );

	$cmb->add_field( array(
	    'name'    => esc_html__('Expired Plans Info', 'meeeksaas'),
	    'desc'    => esc_html__('Override the default Expired plan info notice content', 'meeeksaas'),
	    'id'      => 'meeeksaas_expired_plans_content',
	    'default' => meeeksaas_expired_plans_notice(),
	    'type'    => 'wysiwyg',
	    'options' => array(),
	) );

	$cmb->add_field( array(
	    'name' => esc_html__('Disable all default templates', 'meeeksaas'),
	    'desc' => esc_html__('I want to disable all default templates and create my own templates.', 'meeeksaas'),
	    'id'   => 'meeeksaas_default_templates',
	    'type' => 'checkbox',
	) );

	// Custom Templates
	$group_field_id = $cmb->add_field( array(
		'name'        => __( 'Custom Import Templates', 'meeeksaas' ),
		'id'          => 'meeeksaas_custom_templates',
		'type'        => 'group',
		'description' => __( 'Search for existing bio link pages and set them as custom templates. The custom templates will be listed at the end of the premade/existing templates.', 'meeeksaas' ),
		'repeatable'  => true,
		'options'     => array(
			'group_title'       => __( 'Template {#}', 'meeeksaas' ), 
			'add_button'        => __( 'Add Another Template', 'meeeksaas' ),
			'remove_button'     => __( 'Remove Template', 'meeeksaas' ),
			'sortable'          => true,
			'closed'         => true,
			'remove_confirm' => esc_html__( 'Are you sure you want to remove?', 'meeeksaas' ), // Performs confirmation before removing group.

		),
	) );
	$cmb->add_group_field( $group_field_id, array(
		'name'        => __( 'Bio Link Page', 'meeeksaas' ),
	    'desc'   	  => esc_html__('Use the search icon to start the searching process. Do Not Edit the ID Manually.', 'meeeksaas'),
		'id'          => 'template_id',
		'type'        => 'post_search_text', // This field type
		'post_type'   => 'meeek-link',
		'select_type' => 'radio',
		'select_behavior' => 'replace',
	) );
	$cmb->add_group_field( $group_field_id,  array(
	    'name'    => esc_html__('Preview Image', 'meeeksaas'),
	    'desc'    => esc_html__('Add a preview image (Landscape Resolution Format)', 'meeeksaas'),
	    'id'      => 'media',
	    'type'    => 'file',
	    // Optional:
	    'options' => array(
	        'url' => false, // Hide the text input for the url
	    ),
	    'text'    => array(
	        'add_upload_file_text' => esc_html__('Upload Image', 'meeeksaas'), // Change upload button text. Default: "Add or Upload File"
	    ),
	    // query_args are passed to wp.media's library query.
	    'query_args' => array(
	        // 'type' => 'application/pdf', // Make library only display PDFs.
	        // Or only allow gif, jpg, or png images
	        'type' => array(
	            'image/gif',
	            'image/jpeg',
	            'image/png',
	        ),
	    ),
	    'preview_size' => 'medium', // Image size to use when previewing in the admin.
	) );

	$cmb->add_field( array(
	    'name' => esc_html__('Disable Elements Status', 'meeeksaas'),
	    'desc' => esc_html__('I want to disable elements', 'meeeksaas'),
	    'id'   => 'meeeksaas_disable_elements',
	    'type' => 'checkbox',
	) );
	$cmb->add_field( array(
	    'name'    => esc_html__('Elements (Check to Disable Elements)', 'meeeksaas'),
	    'desc'    => esc_html__('Check to Disable Elements. All Checked Elements will be disabled. Default/Normal link can\'t be disabled', 'meeeksaas'),
	    'id'      => 'meeeksaas_elements_list',
	    'type'    => 'multicheck',
	    'options' => array(
	        'block' => esc_html__('WordPress Block', 'meeeksaas'),
	        'blog' => esc_html__('Blog Articles', 'meeeksaas'),
	        'dropdown' => esc_html__('Dropdown', 'meeeksaas'),
	        'email' => esc_html__('Email', 'meeeksaas'),
	        'facebook' => esc_html__('Facebook', 'meeeksaas'),
	        'header' => esc_html__('Headers', 'meeeksaas'),
	        'image' => esc_html__('Image', 'meeeksaas'),
	        'twitter' => esc_html__('Twitter', 'meeeksaas'),
	        'tiktok' => esc_html__('TikTok', 'meeeksaas'),
	        'paypal' => esc_html__('PayPal', 'meeeksaas'),
	        'venmo' => esc_html__('Venmo', 'meeeksaas'),
	        'phone' => esc_html__('Phone', 'meeeksaas'),
	        'spotify' => esc_html__('Spotify', 'meeeksaas'),
	        'shortcode' => esc_html__('WordPress Shortcode', 'meeeksaas'),
	        'woocommerce' => esc_html__('WooCommerce Products', 'meeeksaas'),
	        'vcard' => esc_html__('vCard', 'meeeksaas'),
	        'youtube' => esc_html__('YouTube', 'meeeksaas'),
	    ),		
	    'attributes' => array(
			'data-conditional-id'    => 'meeeksaas_disable_elements',
			'data-conditional-value' => 'on',
		),
	) );

	$cmb->add_field( array(
	    'name' => esc_html__('Custom CSS', 'meeeksaas'),
	    'desc' => esc_html__('The CSS from this box will be applied globally to all of the bio link pages', 'meeeksaas'),
	    'id' => 'meeeksaas_css',
	    'type' => 'textarea_code'
	) );

	$cmb->add_field( array(
	    'name' => esc_html__('Enable Local Google Fonts', 'meeeksaas'),
	    'desc' => esc_html__('I want to disable references to fonts.googleapis.com and add my Google Fonts locally.', 'meeeksaas'),
	    'id'   => 'meeeksaas_gfonts',
	    'type' => 'checkbox',
	) );

	$cmb->add_field( array(
	    'name' => esc_html__('Custom Pricing Page?', 'meeeksaas'),
	    'desc' => esc_html__('Show link to a custom pricing page instead of the pricing tables (Only on User Accounts page)', 'meeeksaas'),
	    'id'   => 'meeeksaas_custom_pricing_page_status',
	    'type' => 'checkbox',
	) );
	$cmb->add_field( array(
	    'name'    => esc_html__('Custom Pricing Page Link', 'meeeksaas'),
	    'desc'    => esc_html__('Add a link to your Pricing page', 'meeeksaas'),
	    'default' => '',
	    'id'      => 'meeeksaas_custom_pricing_page_link',
	    'type'    => 'text',
	) );

}

function meeeksaas_general_settings_page( $hookup ) {
	?>
	<div class="wrap cmb2-options-page option-<?php echo esc_attr($hookup->option_key); ?>">
        <?php do_action('meeeksaas_before_wrap_tab_content', 'general'); ?>
        <div class="tab-content">
			<form class="cmb-form" action="<?php echo esc_url( admin_url( 'admin-post.php' ) ); ?>" method="POST" id="<?php echo $hookup->cmb->cmb_id; ?>" enctype="multipart/form-data" encoding="multipart/form-data">
				<input type="hidden" name="action" value="<?php echo esc_attr( $hookup->option_key ); ?>">
				<?php $hookup->options_page_metabox(); ?>
				<?php submit_button( esc_attr( $hookup->cmb->prop( 'save_button' ) ), 'primary', 'submit-cmb' ); ?>
			</form>
        </div>
	</div>
	<?php
}