<?php
if ( ! defined( 'ABSPATH' ) ) {
    exit; // Exit if accessed directly.
}
require_once(MEEEKSAAS_PLUGIN_INC.'admin/api-v3/API.php'); 

// Add the settings menu
add_action('admin_menu', 'meeeksaas_settings_panel_menu', 5);
function meeeksaas_settings_panel_menu() {
    add_submenu_page(
        '',
        // null,
        esc_html__( 'Builder', 'meeeksaas' ),
        esc_html__( 'Builder', 'meeeksaas' ),
        'manage_options',
        'meeek-page-builder',
        'meeeksaas_page_builder_body'
    );
    add_submenu_page(
        'edit.php?post_type=meeek-link', 
        esc_html__( 'Add New', 'meeeksaas' ),
        esc_html__( 'Add New', 'meeeksaas' ),
        'manage_options', 
        admin_url('admin.php?page=meeek-page-builder')
    );
    add_submenu_page(
        'edit.php?post_type=meeek-link',  // Parent menu slug
        esc_html__( 'Settings', 'meeeksaas' ),
        esc_html__( 'Settings', 'meeeksaas' ),
        'manage_options',
        'mt-saas-settings',
        'meeeksaas_general_settings_page'
    );
    add_submenu_page(
        'edit.php?post_type=meeek-link',  // Parent menu slug
        esc_html__( 'License Activation', 'meeeksaas' ),
        esc_html__( 'License Activation', 'meeeksaas' ),
        'manage_options',
        'mt-activator',
        'meeeksaas_activator_settings_page'
    );
    add_submenu_page(
        'edit.php?post_type=meeek-link',  // Parent menu slug
        esc_html__( 'Regular vs Extended License', 'meeeksaas' ),
        esc_html__( 'Regular vs Extended License', 'meeeksaas' ),
        'manage_options',
        'mt-saas-regular-vs-extended',
        'meeeksaas_regular_vs_extended_settings_page'
    );
    add_submenu_page(
        'edit.php?post_type=meeek-link',  // Parent menu slug
        esc_html__( 'Documentation', 'meeeksaas' ),
        esc_html__( 'Documentation', 'meeeksaas' ),
        'manage_options',
        'mt-saas-docs',
        'meeeksaas_docs_settings_page'
    );

}



// Activator Tab
function meeeksaas_activator_settings_page() {
    ?>
    <div class="wrap">
        <?php do_action('meeeksaas_before_wrap_tab_content', 'license'); ?>
        <div class="tab-content">
            <?php do_action('meeeksaas_item_license'); ?>
        </div>
    </div>

    <?php
}
// License regular vs extended Tab
function meeeksaas_regular_vs_extended_settings_page() {
    ?>
    <div class="wrap">
        <?php do_action('meeeksaas_before_wrap_tab_content', 'regular-vs-extended'); ?>
        <div class="tab-content">
            <h3><?php esc_html__( 'Regular or Extended License?', 'meeeksaas' ); ?></h3>
            <iframe width="100%" height="800px" src="https://docs.modeltheme.com/meeek-saas/#license"></iframe>
        </div>
    </div>
    <?php
}
// Docs Tab
function meeeksaas_docs_settings_page() {
    ?>
    <div class="wrap">
        <?php do_action('meeeksaas_before_wrap_tab_content', 'docs'); ?>
        <div class="tab-content">
            <h3><?php esc_html__( 'Meeek SaaS Documentation', 'meeeksaas' ); ?></h3>
            <iframe width="100%" height="800px" src="https://docs.modeltheme.com/meeek-saas/"></iframe>
        </div>
    </div>
    <?php
}

require('settings.general.php');

function meeeksaas_settings_tabs($tab_id){
    ?>
        <h2 class="nav-tab-wrapper">
            <a href="?post_type=meeek-link&page=mt-saas-settings" class="nav-tab <?php if($tab_id == 'general'){echo 'nav-tab-active';} ?>"><?php echo esc_html__('General Settings', 'meeksaas'); ?></a>
            <?php if (function_exists('meeek_saas_benefits_list')){ ?>
                <a href="?post_type=meeek-link&page=pricing" class="nav-tab <?php if($tab_id == 'pricing'){echo 'nav-tab-active';} ?>"><?php echo esc_html__('Pricing Packages', 'meeksaas'); ?></a>
            <?php } ?>
            <a href="?post_type=meeek-link&page=mt-activator" class="nav-tab <?php if($tab_id == 'license'){echo 'nav-tab-active';} ?>"><?php echo esc_html__('License Activation', 'meeksaas'); ?></a>
            <a href="?post_type=meeek-link&page=mt-saas-regular-vs-extended" class="nav-tab <?php if($tab_id == 'regular-vs-extended'){echo 'nav-tab-active';} ?>"><?php echo esc_html__('Regular License vs Extended', 'meeksaas'); ?></a>
            <a href="?post_type=meeek-link&page=mt-saas-docs" class="nav-tab <?php if($tab_id == 'docs'){echo 'nav-tab-active';} ?>"><?php echo esc_html__('Documentation', 'meeksaas'); ?></a>
        </h2>
    <?php 
}
add_action('meeeksaas_before_wrap_tab_content', 'meeeksaas_settings_tabs');