<?php
if ( ! defined( 'ABSPATH' ) ) {
    exit; // Exit if accessed directly.
}

// process the form
require_once('builder.fields.php');
require_once('builder.save.php');
require_once(MEEEKSAAS_PLUGIN_INC.'/import/import.php');

// Generate the settings panel page
add_action('meeeksaas_page_builder_frontend', 'meeeksaas_page_builder_body');
function meeeksaas_page_builder_body($post_id = '') {

    $current_user = wp_get_current_user();
    $user_id = $current_user->ID;
    $username = $current_user->user_login;

    if ($post_id) {
        $current_post_id = $post_id;
    }else{
        if (isset($_GET['links_page'])) {
            $current_post_id = $_GET['links_page'];
        }else{
            if (isset($_POST['post_id'])) {
                $current_post_id = $_POST['post_id'];
            }else{
                $current_post_id = '';
                $current_post_link = '';
            }
        }
    }

    $meeek_configuration = array();
    if (isset($_GET['use_template']) && !empty($_GET['use_template'])) {
        $meeek_configuration = meeeksaas_quickstart_template($_GET['use_template']);
    }else{
        if (get_post_meta( $current_post_id, 'meeek_configuration', true )) {
            $meeek_configuration = get_post_meta( $current_post_id, 'meeek_configuration', true );
        }
    }

    $buttons_groups =       ((array_key_exists('meeek-bio-links-group', $meeek_configuration))?$meeek_configuration['meeek-bio-links-group']:array());
    $icons_color =          ((array_key_exists('meeeksaas_icons_color', $meeek_configuration))?$meeek_configuration['meeeksaas_icons_color']:"#000000");
    $icons_alignment =      ((array_key_exists('icons_alignment', $meeek_configuration))?$meeek_configuration['icons_alignment']:"center");
    $icons_status =         ((array_key_exists('icons_status', $meeek_configuration))?$meeek_configuration['icons_status']:"on");
    $mailto_sm_link =         ((array_key_exists('mailto_sm_link', $meeek_configuration))?$meeek_configuration['mailto_sm_link']:"off");
    $icons_position =         ((array_key_exists('icons_position', $meeek_configuration))?$meeek_configuration['icons_position']:"after");
    $user_bio_color =       ((array_key_exists('user_bio_color', $meeek_configuration))?$meeek_configuration['user_bio_color']:"#000000");
    $user_bio_photo_radius =   ((array_key_exists('user_bio_photo_radius', $meeek_configuration))?$meeek_configuration['user_bio_photo_radius']:"circle");
    $user_bio_alignment =   ((array_key_exists('user_bio_alignment', $meeek_configuration))?$meeek_configuration['user_bio_alignment']:"center");
    $version =              ((array_key_exists('version', $meeek_configuration))?$meeek_configuration['version']:"v1");
    $container_width =      ((array_key_exists('container_width', $meeek_configuration))?$meeek_configuration['container_width']:"550");
    $ga_tag_id =            ((array_key_exists('ga_tag_id', $meeek_configuration))?$meeek_configuration['ga_tag_id']:"");
    $container_tb_space =   ((array_key_exists('container_tb_space', $meeek_configuration))?$meeek_configuration['container_tb_space']:"100");
    $user_photo_id =        ((array_key_exists('user_photo_id', $meeek_configuration))?$meeek_configuration['user_photo_id']:"");
    $user_photo_id_url =    ((array_key_exists('user_photo_id_url', $meeek_configuration))?$meeek_configuration['user_photo_id_url']:"");
    $user_name =            ((array_key_exists('user_name', $meeek_configuration))?$meeek_configuration['user_name']:"");
    $user_bio =             ((array_key_exists('user_bio', $meeek_configuration))?$meeek_configuration['user_bio']:"");
    $icons_groups =         ((array_key_exists('meeek-sm-links-group', $meeek_configuration))?$meeek_configuration['meeek-sm-links-group']:"");
    $seo_indexable =        ((array_key_exists('seo_indexable', $meeek_configuration))?$meeek_configuration['seo_indexable']:"off");
    $seo_page_slug =        ((array_key_exists('seo_page_slug', $meeek_configuration))?$meeek_configuration['seo_page_slug']:esc_attr($username));
    $seo_page_slug_id =     ((array_key_exists('seo_page_slug_id', $meeek_configuration))?$meeek_configuration['seo_page_slug_id']:"");
    if(!$seo_page_slug_id){
        $seo_page_slug_id = meeeksaas_generate_link_id();
    }
    $header_alignment =       ((array_key_exists('header_alignment', $meeek_configuration))?$meeek_configuration['header_alignment']:"center");
    $seo_page_title =       ((array_key_exists('seo_page_title', $meeek_configuration))?$meeek_configuration['seo_page_title']:esc_attr($username));
    $user_name_padding =    ((array_key_exists('user_name_padding', $meeek_configuration))?$meeek_configuration['user_name_padding']:array('', '', '', ''));
    $user_bio_padding =     ((array_key_exists('user_bio_padding', $meeek_configuration))?$meeek_configuration['user_bio_padding']:array('', '', '', ''));
    $body_bg_image_id =     ((array_key_exists('body_bg_image', $meeek_configuration))?$meeek_configuration['body_bg_image']:"");
    $body_bg_image_url =    ((array_key_exists('body_bg_image_url', $meeek_configuration))?$meeek_configuration['body_bg_image_url']:"");
    $body_bg_color =        ((array_key_exists('body_bg_color', $meeek_configuration))?$meeek_configuration['body_bg_color']:"");
    $brand_logo_status =    ((array_key_exists('brand_logo_status', $meeek_configuration))?$meeek_configuration['brand_logo_status']:"on");

    // fonts
    $style_pagename_font =       ((array_key_exists('style_pagename_font', $meeek_configuration))?$meeek_configuration['style_pagename_font']:'');
    $style_headings_font =       ((array_key_exists('style_headings_font', $meeek_configuration))?$meeek_configuration['style_headings_font']:'');
    $style_links_font =       ((array_key_exists('style_links_font', $meeek_configuration))?$meeek_configuration['style_links_font']:'');
    $style_content_font =       ((array_key_exists('style_content_font', $meeek_configuration))?$meeek_configuration['style_content_font']:'');



    // Branding/Whitelabel
    $brand_logo = MEEEKSAAS_LOGO_PATH;
    $settings = get_option('mt-saas-settings');
    if ($settings) {
        $whitelabel_logo_id = ((array_key_exists('meeeksaas_whitelabel_logo_id', $settings))?$settings['meeeksaas_whitelabel_logo_id']:"");
        $builder_preview = ((array_key_exists('meeeksaas_builder_preview', $settings))?$settings['meeeksaas_builder_preview']:"responsive");
        if (!empty($whitelabel_logo_id)) {
            $brand_logo = wp_get_attachment_url($whitelabel_logo_id);
        }
    } ?>

    <?php if (meeeksaas_user_has_builder_access()) { ?>
        <div class="wrap relative">
            <!-- Header -->
            <header class="p-3 bg-dark text-white">
                <div class="">
                    <div class="d-flex flex-wrap align-items-center justify-content-center justify-content-lg-start">
                        <a href="#" class="meeeksaas-builder-logo d-flex align-items-center mb-2 mb-lg-0 text-white text-decoration-none">
                            <img src="<?php echo esc_url($brand_logo); ?>" alt="logo" width="80" />
                        </a>

                        <ul class="nav nav-tabs meeek-nav-tabs col-12 col-lg-auto me-lg-auto mb-2 justify-content-center mb-md-0" role="tablist">
                            <li class="nav-item" role="presentation">
                                <button data-attr="tab" data-attr-val="links" class="nav-link <?php if(meeeksaas_builder_active_tab() == 'links'){echo 'active';} ?>" id="links-tab" data-bs-toggle="tab" data-bs-target="#links" type="button" role="tab" aria-controls="general-settings" aria-selected="true">
                                <i class="fas fa-link"></i> <?php esc_html_e('Links', 'meeeksaas'); ?></button>
                            </li>
                            <li class="nav-item" role="presentation">
                                <button data-attr="tab" data-attr-val="profile" class="nav-link <?php if(meeeksaas_builder_active_tab() == 'profile'){echo 'active';} ?>" id="advanced-settings-tab" data-bs-toggle="tab" data-bs-target="#advanced-settings" type="button" role="tab" aria-controls="advanced-settings" aria-selected="false">
                                <i class="fas fa-pencil-alt"></i> <?php esc_html_e('Profile', 'meeeksaas'); ?></button>
                            </li>
                            <li class="nav-item" role="presentation">
                                <button data-attr="tab" data-attr-val="social-icons" class="nav-link <?php if(meeeksaas_builder_active_tab() == 'social-icons'){echo 'active';} ?>" id="social-media-settings-tab" data-bs-toggle="tab" data-bs-target="#social-media-settings" type="button" role="tab" aria-controls="social-media-settings" aria-selected="false">
                                <i class="far fa-smile"></i> <?php esc_html_e('Social Media Icons', 'meeeksaas'); ?></button>
                            </li>
                            <li class="nav-item" role="presentation">
                                <button data-attr="tab" data-attr-val="general" class="nav-link <?php if(meeeksaas_builder_active_tab() == 'general'){echo 'active';} ?>" id="general-settings-tab" data-bs-toggle="tab" data-bs-target="#general-settings" type="button" role="tab" aria-controls="general-settings" aria-selected="false">
                                <i class="bi bi-sliders"></i> <?php esc_html_e('General Styling', 'meeeksaas'); ?></button>
                            </li>
                            <li class="nav-item" role="presentation">
                                <button data-attr="tab" data-attr-val="analytics" class="nav-link <?php if(meeeksaas_builder_active_tab() == 'analytics'){echo 'active';} ?>" id="analytics-tab" data-bs-toggle="tab" data-bs-target="#analytics-settings" type="button" role="tab" aria-controls="analytics-settings" aria-selected="false">
                                <i class="bi bi-graph-up-arrow"></i> <?php esc_html_e('Analytics', 'meeeksaas'); ?></button>
                            </li>
                        </ul>

                        <div class="text-end">
                            <button type="button" class="btn btn-outline-light meeek-seo-modal" data-bs-toggle="modal" data-bs-target="#meeeksaas_seo_modal"><?php esc_html_e('SEO Settings', 'meeeksaas'); ?></button>
                            <button type="button" class="btn btn-warning meeeksaas_share_modal" data-bs-toggle="modal" data-bs-target="#meeeksaas_share_modal"><i class="fas fa-external-link-alt"></i> <?php esc_html_e('Share', 'meeeksaas'); ?></button>
                            <a data-bs-toggle="tooltip" data-bs-placement="top" data-bs-title="Preview" class="btn btn-primary" href="<?php echo get_permalink($current_post_id); ?>" target="_blank"><i class="far fa-eye"></i></a>
                        </div>
                    </div>
                </div>
            </header>

            <!-- Container -->
            <div class="container-fluid meeek-settings-full-container">
                <div class="d-grid">
                    <!-- Builder -->
                    <div class="bg-light p-4">
                        <form id="meeeksaas-builder-form" class="meeek-configuration-form" method="POST">
                            <input type="hidden" name="user_id" value="<?php echo esc_attr($user_id); ?>" />
                            <input type="hidden" id="meeeksaas_post_id" name="post_id" value="<?php echo esc_attr($current_post_id); ?>" />

                            <div class="tab-content">
                                <div id="links" class="tab-pane fade show <?php if(meeeksaas_builder_active_tab() == 'links'){echo 'active';} ?>" role="tabpanel" aria-labelledby="links-tab">
                                    <h4><?php esc_html_e('Add Bio Button Links.', 'meeeksaas'); ?></h4>

                                    <div class="mt-3 mb-3">
                                        <button type="button" class="mb-2 btn btn-sm btn-secondary meeek-btn-styles-modal" data-bs-toggle="modal" data-bs-target="#meeeksaas_btn_styles_modal"><i class="fas fa-paint-brush"></i> <?php esc_html_e('Button Style', 'meeeksaas'); ?></button>
                                        <button type="button" class="mb-2 btn btn-sm btn-outline-secondary meeek-templates-modal" data-bs-toggle="modal" data-bs-target="#meeeksaas_skins_modal"><i class="fas fa-drafting-compass"></i> <?php esc_html_e('Start from a Template', 'meeeksaas'); ?></button>
                                    </div>

                                    <?php 
                                    if (isset($_GET['use_template']) && !empty($_GET['use_template'])) {
                                        ?>
                                            <div class="alert alert-success d-flex align-items-center alert-dismissible fade show" role="alert">
                                                <div>
                                                <?php 
                                                    $import_template_id = $_GET['use_template'];
                                                    if (is_integer($import_template_id)) {
                                                        $template_name = get_the_title($import_template_id);
                                                    }else{
                                                        $template_name = $import_template_id;
                                                    }

                                                    printf(
                                                        /* translators: %s: template variant */
                                                        __( 'Template loaded successfully. Save the changes to preview the new page.', 'meeeksaas' ),
                                                        esc_attr($template_name)
                                                    );
                                                ?>
                                                </div>
                                                <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>
                                            </div>
                                        <?php
                                    }
                                    ?>

                                    <div class="meeek-buttons-group">
                                        <div data-repeater-list="meeek-bio-links-group" class="meeek-buttons-group-inner accordion">
                                            <?php 
                                            if ($buttons_groups) {
                                                foreach ($buttons_groups as $key => $button) {
                                                    $photo_id = '';
                                                    $photo_img = '';
                                                    if(array_key_exists('btn_photo_id', $button)){
                                                        $photo_id = $button['btn_photo_id'];
                                                    }
                                                    if(array_key_exists('btn_photo_id_url', $button)){
                                                        $photo_img = $button['btn_photo_id_url'];
                                                    }
                                                    $element_type = $button['btn_type'];

                                                    $toggle_status =    ((array_key_exists('toggle_status', $button))?$button['toggle_status'][0]:"off");
                                                    $is_whatsapp =    ((array_key_exists('is_whatsapp', $button))?$button['is_whatsapp'][0]:"off");
                                                    $attachment_id =    ((array_key_exists('attachment_id', $button))?$button['attachment_id']:"");
                                                    $attachment_radius =    ((array_key_exists('attachment_radius', $button))?$button['attachment_radius']:"rounded");
                                                    $title_color =    ((array_key_exists('title_color', $button))?$button['title_color']:"#000000");
                                                    $title_alignment =    ((array_key_exists('title_alignment', $button))?$button['title_alignment']:"center");
                                                    $attachment_url = '';
                                                    if ($attachment_id) {
                                                        $attachment_url = wp_get_attachment_image_url($attachment_id, 'full');
                                                    }
                                                    ?>

                                                    <div data-repeater-item class="accordion-item meeek-bio-links-inner-dropdown meeek-accordion-card" data-element-type="<?php echo esc_attr($element_type); ?>">
                                                        <div class="meeek-accordion-card-inner">
                                                            <div class="meeek-accordion-title relative" data-accordion-element-trigger>
                                                                <i class="fas fa-grip-vertical meeek-reorder-btn"></i>
                                                                <?php do_action('meeeksaas_builder_before_accordion_title', $element_type); ?>
                                                                <?php echo esc_html($button['title']); ?>
                                                                <?php do_action('meeeksaas_builder_after_accordion_title', $element_type); ?>
                                                                <i data-repeater-delete class="bi bi-trash"></i>
                                                            </div>

                                                            <div data-accordion-element-content class="meeek-accordion-content">
                                                                <div class="accordion-body">
                                                                    <div class="card-body">
                                                                        <input type="hidden" name="btn_type" value="<?php echo esc_attr($element_type); ?>" />
                                                                        <?php if($element_type == 'btn_button'){ ?>
                                                                            <?php 
                                                                                echo meeeksaas_input('text', 'title', $button['title'], esc_html__('Title', 'meeeksaas'), 'meeeksaas_title', true);
                                                                                echo meeeksaas_input('url', 'link', $button['link'], esc_html__('Link', 'meeeksaas'), 'meeeksaas_link', true);
                                                                                // echo meeeksaas_colorpicker('btn_color', $button['btn_color'], esc_html__('Button Background', 'meeeksaas'), 'meeeksaas_btn_color');
                                                                                echo meeeksaas_media_uploader('btn_photo_id', esc_attr($photo_id), esc_url($photo_img), esc_html__('Button Thumbnail', 'meeeksaas'), 'allow_bg');
                                                                                echo meeeksaas_iconpicker('btn_icon', $button['btn_icon'], esc_html__('Icon', 'meeeksaas'), esc_html__('Pick an icon', 'meeeksaas'), 'meeeksaas_btn_icon');
                                                                            ?>
                                                                        <?php }elseif($element_type == 'header'){?>
                                                                            <?php 
                                                                                echo meeeksaas_input('text', 'title', $button['title'], esc_html__('Title', 'meeeksaas'), 'meeeksaas_title', true);
                                                                                echo meeeksaas_colorpicker('header_color', $button['header_color'], esc_html__('Color', 'meeeksaas'), 'header_color');
                                                                                echo meeeksaas_alignment_group('header_alignment', $header_alignment, esc_html__('Alignment', 'meeeksaas'));
                                                                            ?>
                                                                        <?php }elseif($element_type == 'image'){?>
                                                                            <?php 
                                                                                echo meeeksaas_input('text', 'title', $button['title'], esc_html__('Title (Optional)', 'meeeksaas'), 'meeeksaas_title', true);
                                                                                echo meeeksaas_input('url', 'link', $button['link'], esc_html__('Link (Optional)', 'meeeksaas'), 'meeeksaas_link', true);
                                                                                echo meeeksaas_media_uploader('attachment_id', esc_attr($attachment_id), esc_url($attachment_url), esc_html__('Image', 'meeeksaas'), 'allow_image');
                                                                                echo meeeksaas_radius_group('attachment_radius', $attachment_radius, esc_html__('Image Radius', 'meeeksaas'));
                                                                                echo meeeksaas_colorpicker('title_color', $title_color, esc_html__('Title Color', 'meeeksaas'), 'title_color');
                                                                                echo meeeksaas_alignment_group('title_alignment', $title_alignment, esc_html__('Title Alignment', 'meeeksaas'));
                                                                            ?>
                                                                        <?php }elseif($element_type == 'paypal' || $element_type == 'venmo'){?>
                                                                            <?php 
                                                                                echo meeeksaas_input('text', 'title', $button['title'], esc_html__('Title', 'meeeksaas'), 'meeeksaas_title', true);
                                                                                echo meeeksaas_input('text', 'link', $button['link'], esc_html__('PayPal Link or Email', 'meeeksaas'), 'meeeksaas_link', true);
                                                                                echo meeeksaas_checkbox('toggle_status', 'toggle_status', esc_html__('Donation Popup', 'meeeksaas'), $toggle_status);
                                                                            ?>
                                                                        <?php }elseif($element_type == 'phone'){?>
                                                                            <?php 
                                                                                echo meeeksaas_input('text', 'title', $button['title'], esc_html__('Number', 'meeeksaas'), 'meeeksaas_title', true);
                                                                                echo meeeksaas_checkbox('is_whatsapp', 'is_whatsapp', esc_html__('Is this a WhatsApp Number?', 'meeeksaas'), $is_whatsapp);
                                                                            ?>
                                                                        <?php }elseif($element_type == 'email'){?>
                                                                            <?php 
                                                                                echo meeeksaas_input('text', 'title', $button['title'], esc_html__('Button Text', 'meeeksaas'), 'meeeksaas_title', true);
                                                                                echo meeeksaas_input('text', 'email_to', $button['email_to'], esc_html__('Email To', 'meeeksaas'), 'email_to', true);
                                                                                echo meeeksaas_input('text', 'email_subject', $button['email_subject'], esc_html__('Email Subject', 'meeeksaas'), 'email_subject', true);
                                                                                echo meeeksaas_textarea('email_body', $button['email_body'], esc_html__('Email Content', 'meeeksaas'), 'email_body', true);
                                                                            ?>
                                                                        <?php }elseif($element_type == 'dropdown'){?>
                                                                            <?php 
                                                                                echo meeeksaas_input('text', 'title', $button['title'], esc_html__('Title', 'meeeksaas'), 'meeeksaas_title', true);
                                                                                echo meeeksaas_textarea('content', $button['content'], esc_html__('Content', 'meeeksaas'), 'meeeksaas_description', true);
                                                                            ?>
                                                                        <?php }elseif($element_type == 'woocommerce'){?>
                                                                            <?php 
                                                                                echo meeeksaas_input('text', 'title', $button['title'], esc_html__('Title', 'meeeksaas'), 'meeeksaas_title', true);
                                                                                echo meeeksaas_ajax_select2('link', 'link', esc_html__('Select Products', 'meeeksaas'), $button['link'], 'product', 'allow_woocommerce');
                                                                            ?>
                                                                        <?php }elseif($element_type == 'blog'){?>
                                                                            <?php 
                                                                                echo meeeksaas_input('text', 'title', $button['title'], esc_html__('Title', 'meeeksaas'), 'meeeksaas_title', true);
                                                                                echo meeeksaas_ajax_select2('link', 'link', esc_html__('Select Articles', 'meeeksaas'), $button['link'], 'post', 'allow_blog');
                                                                            ?>
                                                                        <?php } elseif($element_type == 'vcard'){?>
                                                                            <div class="row">
                                                                            <?php 
                                                                                echo meeeksaas_input('text', 'title', $button['title'], esc_html__('Button Title', 'meeeksaas'), 'meeeksaas_title', false, 'col-md-12');
                                                                                echo meeeksaas_input('text', 'vcard_first_name', $button['vcard_first_name'], esc_html__('First Name', 'meeeksaas'), 'vcard_last_name', false, 'col-md-6');
                                                                                echo meeeksaas_input('text', 'vcard_last_name', $button['vcard_last_name'], esc_html__('Last Name', 'meeeksaas'), 'vcard_first_name', false, 'col-md-6');
                                                                                echo meeeksaas_input('text', 'vcard_mobile', $button['vcard_mobile'], esc_html__('Mobile', 'meeeksaas'), 'vcard_mobile', false, 'col-md-6');
                                                                                echo meeeksaas_input('text', 'vcard_phone', $button['vcard_phone'], esc_html__('Phone', 'meeeksaas'), 'vcard_phone', false, 'col-md-6');
                                                                                echo meeeksaas_input('text', 'vcard_fax', $button['vcard_fax'], esc_html__('Fax', 'meeeksaas'), 'vcard_fax', false, 'col-md-6');
                                                                                echo meeeksaas_input('text', 'vcard_email', $button['vcard_email'], esc_html__('Email', 'meeeksaas'), 'vcard_email', false, 'col-md-12');
                                                                                echo meeeksaas_input('text', 'vcard_company', $button['vcard_company'], esc_html__('Company', 'meeeksaas'), 'vcard_company', false, 'col-md-6');
                                                                                echo meeeksaas_input('text', 'vcard_job', $button['vcard_job'], esc_html__('Your Job', 'meeeksaas'), 'vcard_job', false, 'col-md-6');
                                                                                echo meeeksaas_input('text', 'vcard_street', $button['vcard_street'], esc_html__('Street', 'meeeksaas'), 'vcard_street', false, 'col-md-12');
                                                                                echo meeeksaas_input('text', 'vcard_city', $button['vcard_city'], esc_html__('City', 'meeeksaas'), 'vcard_city', false, 'col-md-6');
                                                                                echo meeeksaas_input('text', 'vcard_zip', $button['vcard_zip'], esc_html__('Zipcode', 'meeeksaas'), 'vcard_zip', false, 'col-md-6');
                                                                                echo meeeksaas_input('text', 'vcard_state', $button['vcard_state'], esc_html__('State', 'meeeksaas'), 'vcard_state', false, 'col-md-12');
                                                                                echo meeeksaas_input('text', 'vcard_country', $button['vcard_country'], esc_html__('Country', 'meeeksaas'), 'vcard_country', false, 'col-md-12');
                                                                                echo meeeksaas_input('url', 'link', $button['link'], esc_html__('Website:', 'meeeksaas'), 'meeeksaas_link', false, 'col-md-12');
                                                                            ?>
                                                                            </div>
                                                                        <?php }elseif($element_type == 'shortcode'){?>
                                                                            <?php 
                                                                                echo meeeksaas_input('text', 'title', $button['title'], esc_html__('Title', 'meeeksaas'), 'meeeksaas_title', true);
                                                                                echo meeeksaas_textarea('content', $button['content'], esc_html__('Shortcode Content', 'meeeksaas'), 'meeeksaas_description', true);
                                                                                echo meeeksaas_checkbox('toggle_status', 'toggle_status', esc_html__('Outside Toggle', 'meeeksaas'), $toggle_status);
                                                                            ?>
                                                                        <?php }elseif($element_type == 'block'){?>
                                                                            <?php 
                                                                                echo meeeksaas_input('text', 'title', $button['title'], esc_html__('Title', 'meeeksaas'), 'meeeksaas_title', true);
                                                                                echo meeeksaas_textarea('content', $button['content'], esc_html__('Block Content', 'meeeksaas'), 'meeeksaas_description', true);
                                                                                echo meeeksaas_checkbox('toggle_status', 'toggle_status', esc_html__('Outside Toggle', 'meeeksaas'), $toggle_status);
                                                                            ?>
                                                                        <?php }elseif($element_type == 'newsletter'){?>
                                                                            <?php 
                                                                                do_action('meeeksaas_newsletter_builder_fields', $button);
                                                                            ?>
                                                                        <?php }elseif($element_type == 'booking'){?>
                                                                            <?php 
                                                                                do_action('meeeksaas_booking_builder_fields', $button);
                                                                            ?>
                                                                        <?php }elseif($element_type == 'gallery'){?>
                                                                            <?php 
                                                                                do_action('meeeksaas_gallery_builder_fields', $button);
                                                                            ?>
                                                                        <?php } elseif($element_type == 'ticket'){?>
                                                                            <?php 
                                                                                do_action('meeeksaas_ticket_builder_fields', $button);
                                                                            ?>
                                                                        <?php } ?>

                                                                        <?php 
                                                                            do_action('meeeksaas_builder_element_fields', $button);
                                                                            do_action('meeeksaas_builder_after_element_fields', $button);
                                                                        ?>
                                                                    </div>
                                                                </div>
                                                            </div>
                                                        </div>
                                                    </div>
                                                    <?php
                                                }
                                            }else{
                                                require_once('elements/button.php');
                                            } ?>
                                        </div>

                                        <div class="meeek-btns mt-3 mb-3">
                                            <a class="btn btn-dark btn-sm meeek-element-importer-btn" data-element-type="button"><i class="bi bi-patch-plus"></i> <?php esc_html_e('Add New Link', 'meeeksaas'); ?></a>
                                            <a class="btn btn-secondary btn-sm meeek-elements-modal" data-bs-toggle="modal" data-bs-target="#meeeksaas_elements_modal"><i class="far fa-compass"></i> <?php esc_html_e('More Element Types', 'meeeksaas'); ?></a>
                                        </div>
                                    </div>
                                </div>

                                <div id="advanced-settings" class="tab-pane fade <?php if(meeeksaas_builder_active_tab() == 'profile'){echo 'active';} ?>" role="tabpanel" aria-labelledby="advanced-settings-tab">
                                    <h4><?php esc_html_e('Upload a profile image, add a title and a bio.', 'meeeksaas'); ?></h4>
                                    <fieldset class="meeeksaas-fsw border p-2 relative">
                                        <legend class="float-none w-auto"><?php esc_html_e('Profile Information', 'meeeksaas'); ?></legend>
                                        <?php 
                                            echo meeeksaas_media_uploader('user_photo_id', esc_attr($user_photo_id), esc_url($user_photo_id_url), esc_html__('Avatar', 'meeeksaas'), 'allow_bio');
                                            echo meeeksaas_input('text', 'user_name', $user_name, esc_html__('Name', 'meeeksaas'), 'user_name', true);
                                            echo meeeksaas_textarea('user_bio', $user_bio, esc_html__('Biography', 'meeeksaas'), 'user_bio', true);
                                        ?>
                                    </fieldset>

                                    <fieldset class="meeeksaas-fsw border p-2 relative">
                                        <legend class="float-none w-auto"><?php esc_html_e('Profile Styling', 'meeeksaas'); ?></legend>
                                        <?php 
                                            echo meeeksaas_radius_group('user_bio_photo_radius', $user_bio_photo_radius, esc_html__('Photo Radius', 'meeeksaas'));
                                            echo meeeksaas_colorpicker('user_bio_color', esc_attr($user_bio_color), esc_html__('Color (Name & Biography)', 'meeeksaas'), 'user_bio_color');
                                            echo meeeksaas_alignment_group('user_bio_alignment', $user_bio_alignment, esc_html__('Alignment (Name & Biography)', 'meeeksaas'));
                                            echo meeeksaas_padding_group('user_name_padding', esc_html__('Name Padding', 'meeeksaas'), $user_name_padding[0], $user_name_padding[1], $user_name_padding[2], $user_name_padding[3]);
                                            echo meeeksaas_padding_group('user_bio_padding', esc_html__('Biography Padding', 'meeeksaas'), $user_bio_padding[0], $user_bio_padding[1], $user_bio_padding[2], $user_bio_padding[3]);
                                        ?>
                                    </fieldset>
                                </div>

                                <div id="social-media-settings" class="tab-pane fade <?php if(meeeksaas_builder_active_tab() == 'social-icons'){echo 'active';} ?>" role="tabpanel" aria-labelledby="social-media-settings-tab">
                                    <h4><?php esc_html_e('Add your social channels to your bio link.', 'meeeksaas'); ?></h4>
                                    <div class="meeek-sm-group relative">
                                        <?php 
                                            echo meeeksaas_checkbox('icons_status', 'icons_status', esc_html__('Social Links Status', 'meeeksaas'), $icons_status);
                                            echo meeeksaas_select('icons_position', 'icons_position', esc_html__('Placement', 'meeeksaas'), $icons_position);
                                            echo meeeksaas_colorpicker('meeeksaas_icons_color', $icons_color, esc_html__('Color', 'meeeksaas'), 'meeeksaas_icons_color');
                                            echo meeeksaas_alignment_group('icons_alignment', $icons_alignment, esc_html__('Alignment', 'meeeksaas'));
                                            echo meeeksaas_checkbox('mailto_sm_link', 'mailto_sm_link', esc_html__('Email Me social link (listed after all the social links). The email is your account email.', 'meeeksaas'), $mailto_sm_link);
                                        ?>
                                        <div data-repeater-list="meeek-sm-links-group" class="meeek-social-icons-group accordion" id="accordionSM">
                                            <?php 
                                                if ($icons_groups) {
                                                    foreach ($icons_groups as $key => $icon) {
                                                        ?>
                                                        <div data-repeater-item class="accordion-item meeek-bio-links-inner-dropdown meeek-accordion-card" data-element-type="social-icon">
                                                            <div class="meeek-accordion-card-inner">
                                                                <div class="meeek-accordion-title" data-accordion-element-trigger>
                                                                    <i class="fas fa-grip-vertical meeek-reorder-btn"></i> 
                                                                    <i class="<?php echo $icon['icon']; ?>"></i>
                                                                    <i data-repeater-delete class="bi bi-trash"></i>
                                                                </div>

                                                                <div data-accordion-element-content class="meeek-accordion-content">
                                                                    <div class="accordion-body">
                                                                        <div class="card-body">
                                                                            <?php 
                                                                                echo meeeksaas_iconpicker('icon', $icon['icon'], esc_html__('Icon', 'meeeksaas'), esc_html__('Pick an icon', 'meeeksaas'), 'meeeksaas_icon');
                                                                                echo meeeksaas_input('url', 'link', $icon['link'], esc_html__('Link', 'meeeksaas'), 'meeeksaas_icon_link', true);
                                                                            ?>
                                                                        </div>
                                                                    </div>
                                                                </div>
                                                            </div>
                                                        </div>
                                                        <?php
                                                    }
                                                }else{
                                                    require_once('elements/social-icon.php');
                                                }
                                            ?>

                                        </div>
                                        <div class="meeek-btns mt-3 mb-3">
                                            <a class="btn btn-dark btn-sm meeek-element-importer-btn" data-element-type="social-icon"><i class="bi bi-patch-plus"></i> <?php esc_html_e('Add Social Icon', 'meeeksaas'); ?></a>
                                        </div>
                                        <?php do_action('meeeksaas_builder_allow_social_icons'); ?>
                                    </div>
                                </div>

                                <div id="general-settings" class="tab-pane fade <?php if(meeeksaas_builder_active_tab() == 'general'){echo 'active';} ?>" role="tabpanel" aria-labelledby="general-settings-tab">
                                    <h4><?php esc_html_e('General Settings', 'meeeksaas'); ?></h4>
                                    <?php 
                                        echo meeeksaas_input_number('container_width', esc_attr($container_width), esc_html__('Container Width', 'meeeksaas'), '600', 'container_width', true);
                                        echo meeeksaas_input_number('container_tb_space', esc_attr($container_tb_space), esc_html__('Container Top/Bottom Space', 'meeeksaas'), '80', 'container_tb_space', true);
                                        echo meeeksaas_colorpicker('body_bg_color', esc_attr($body_bg_color), esc_html__('Body Background Color', 'meeeksaas'), 'body_bg_color');
                                        echo meeeksaas_media_uploader('body_bg_image', esc_attr($body_bg_image_id), esc_url($body_bg_image_url), esc_html__('Body Background Image', 'meeeksaas'), 'allow_body_bg');
                                        echo '<fieldset class="border p-2 relative meeeksaas-fsw">';
                                            echo '<legend class="float-none w-auto">'.esc_html__('Fonts:', 'meeeksaas').'</legend>';
                                                echo '<div class="row">';
                                                    echo meeeksaas_fonts_multiselect('style_pagename_font', esc_attr($style_pagename_font), esc_html__('Author Name Font', 'meeeksaas'), 'style_pagename_font', 'col-md-6');
                                                    echo meeeksaas_fonts_multiselect('style_headings_font', esc_attr($style_headings_font), esc_html__('Headings Font', 'meeeksaas'), 'style_headings_font', 'col-md-6');
                                                    echo meeeksaas_fonts_multiselect('style_links_font', esc_attr($style_links_font), esc_html__('Links Font', 'meeeksaas'), 'style_links_font', 'col-md-6');
                                                    echo meeeksaas_fonts_multiselect('style_content_font', esc_attr($style_content_font), esc_html__('Content Font', 'meeeksaas'), 'style_content_font', 'col-md-6');
                                                echo '</div>';
                                                echo '<p>'.esc_html__('Do not select any fonts if you want to use the global fonts from the website.', 'meeeksaas').'</p>';
                                            echo '</fieldset>';
                                        echo meeeksaas_checkbox('brand_logo_status', 'brand_logo_status', esc_html__('Footer Brand Logo Status', 'meeeksaas'), $brand_logo_status, 'allow_branding');
                                    ?>
                                </div>

                                <div id="analytics-settings" class="tab-pane fade <?php if(meeeksaas_builder_active_tab() == 'analytics'){echo 'active';} ?>" role="tabpanel" aria-labelledby="analytics-tab">
                                    
                                    <?php do_action('meeeksaas_builder_analytics_tab', $current_post_id); ?>

                                    <fieldset class="meeeksaas-analytics border p-2 relative">
                                        <legend class="float-none w-auto"><?php esc_html_e('Google Analytics', 'meeeksaas'); ?></legend>
                                        <?php 
                                            echo meeeksaas_input('text', 'ga_tag_id', $ga_tag_id, esc_html__('Google Analytics Tag ID', 'meeeksaas'), 'ga_tag_id', true);


                                            do_action('meeeksaas_builder_after_ga_fields', array('btn_type' => 'google-analytics'));
                                        ?>
                                        <?php do_action('meeeksaas_builder_allow_g_analytiics'); ?>
                                    </fieldset>
                                </div>

                                <?php do_action('meeeksaas_builder_before_save_changes'); ?>

                                <button name="form_configuration" type="submit" class="btn btn-primary btn-lg"><i class="far fa-save"></i> <?php esc_html_e('Save Changes', 'meeeksaas'); ?></button>
                            </div>

                            <?php require_once('parts/modal-seo.php'); ?>
                            <?php require_once('parts/modal-share.php'); ?>
                            <?php require_once('parts/modal-button-styles.php'); ?>
                        </form>

                        <?php require_once('parts/modal-elements.php'); ?>
                        <?php require_once('parts/modal-templates.php'); ?>
                    </div>
                    <!-- Preview -->
                    <div class="meek-preview-box <?php echo esc_attr($builder_preview); ?>">
                        <div class="meek-preview-box">

                            <?php do_action('meeeksaas_builder_before_preview_box', $current_post_id); ?>

                            <?php if(!empty($current_post_id)){ ?>
                                <?php $current_post_link = get_the_permalink($current_post_id); ?>
                                <iframe id="meeek-preview-frame" src="<?php echo esc_url($current_post_link); ?>?scroll=off"></iframe>
                            <?php }else{ ?>
                                <div class="meek-preview-box-no-preview"><?php echo esc_html__('Save the changes to see the preview.'); ?></div>
                            <?php } ?>
                        </div>
                    </div>
                </div>
            </div>

            <?php do_action('meeeksaas_after_page_builder'); ?>
        </div>
    <?php }else{ ?>
        <?php 
        if (meeeksaas_user_pages_limit_reached()) {
            do_action('meeeksaas_builder_notice'); 
        }
        if (!meeeksaas_user_has_builder_access()) {
            do_action('meeeksaas_no_active_plans_notice', 'builder'); 
        }
        ?>
    <?php } ?>

    <?php
}
