<?php
if ( ! defined( 'ABSPATH' ) ) {
    exit; // Exit if accessed directly.
}

// Save the setting value
function meeeksaas_page_builder_save_settings() {

    if (isset($_POST['form_configuration'])) {
        
        $configuration = $_POST;
        $post_name = $configuration['seo_page_slug'];
        if(function_exists('user_has_benefit') && !user_has_benefit('allow_seo_clean_url')){
            $post_name_slug_id =     ((array_key_exists('seo_page_slug_id', $configuration))?$configuration['seo_page_slug_id']:"");
            if (isset($post_name_slug_id) && !empty($post_name_slug_id)) {
                $post_name .= $post_name_slug_id;
            }
        }
        $post_title = $configuration['seo_page_title'];

        if (empty($configuration['post_id'])) {

            $post_id = wp_insert_post([
                'post_title' => esc_attr($post_title),
                'post_name' => esc_attr($post_name),
                'post_status' => 'publish',
                'post_type' => 'meeek-link',
                'post_author' => wp_get_current_user()->ID,
            ]);

            $_POST['post_id'] = $post_id;
            $configuration['post_id'] = $post_id;
            update_post_meta($post_id, 'meeek_configuration', $configuration);
        }else{
            $post_id = $configuration['post_id'];
            update_post_meta($post_id, 'meeek_configuration', $configuration);

            $meeek_configuration = get_post_meta( $post_id, 'meeek_configuration', true );

            $current_post = array(
                'ID' => $post_id,
            );
            if (get_post_field( 'post_name', $post_id ) != $post_name) {
                $current_post['post_name'] = esc_attr($post_name);
            }
            if (get_the_title($post_id) != $post_title) {
                $current_post['post_title'] = esc_attr($post_title);
            }

            // Update the post into the database
            wp_update_post( $current_post );
        }
    }
}

add_action('admin_init', 'meeeksaas_page_builder_save_settings');
add_action('init', 'meeeksaas_page_builder_save_settings');




// Implement the media uploader
function meeeksaas_page_builder_media_uploader() {
    ?>
    <script>
        jQuery(document).ready(function($) {
            meeeksaas_media_uploader_field_init();
        });
    </script>
    <?php
}

// Hook into the admin_footer action
// add_action('admin_footer', 'meeeksaas_page_builder_media_uploader');
// add_action('wp_footer', 'meeeksaas_page_builder_media_uploader');