<?php
if ( ! defined( 'ABSPATH' ) ) {
    exit; // Exit if accessed directly.
}

// vCard
function meeeksaas_vcard_frontend($type = '', $title = '', $link = ''){
    if($type == 'vcard'){
        if (empty($link)) {
            $link = '';
        }
        $vcard =
        "BEGIN:VCARD\r\n".
        "VERSION:3.0\r\n".
        "N:".$link['vcard_first_name'].";".$link['vcard_last_name']."\r\n".
        "FN:" . $link['vcard_first_name'] . " " . $link['vcard_last_name'] . "\r\n".
        "ORG:" . $link['vcard_company'] . "\r\n".
        "TITLE:" . $link['vcard_job'] . " [" . $link['vcard_company'] . "]\r\n".
        "TEL;CELL:".$link['vcard_mobile']."\r\n".
        "TEL;VOICE;WORK:".$link['vcard_phone']."\r\n".
        "TEL;FAX:".$link['vcard_fax']."\r\n".
        "EMAIL;TYPE=work:".$link['vcard_email']."\r\n".
        "ADR:".$link['vcard_street'].";".$link['vcard_city'].";".$link['vcard_zip'].";".$link['vcard_state'].";".$link['vcard_country']."\r\n".
        "URL:".$link['link']."\r\n".
        "END:VCARD\r\n";

        $qr_url = add_query_arg( 'data', urlencode( $vcard ), 'https://api.qrserver.com/v1/create-qr-code/?size=500x500&qzone=3&cht=qr&choe=UTF-8&chld=L|2' );
        ?>
    <div class="meeek-bio-links-inner-dropdown meeeksass-vcard-qr-toggle meeek-accordion-card mb-3">
        <div class="meeek-accordion-card-inner">
            <div class="meeek-accordion-title" data-accordion-element-trigger>
                <i class="far fa-address-book"></i> <?php echo esc_html($title); ?>
            </div>
            <div data-accordion-element-content class="meeek-accordion-content">
                <a href="<?php echo $qr_url; ?>">
                    <img src="<?php echo $qr_url; ?>" alt="QR" />
                </a>
            </div>
        </div>
    </div>
    <?php
    }
}
add_action('meeeksaas_bio_links_bottom', 'meeeksaas_vcard_frontend', 10, 3);



// Blog Posts
function meeeksaas_blog_frontend($type = '', $title = '', $pids = ''){
    if($type == 'blog'){
        if (empty($pids)) {
            $pids = array();
        }

        $posts = new WP_Query( array( 
            'post_status' => 'publish', // if you don't want drafts to be returned
            'post_type' => 'post', // if you don't want drafts to be returned
            'post__in' => $pids, // if you don't want drafts to be returned
        ) );

        ?>
        <div class="meeek-bio-links-inner-dropdown meeek-accordion-card mb-3">
            <div class="meeek-accordion-card-inner">
                <div class="meeek-accordion-title" data-accordion-element-trigger>
                    <?php echo esc_html($title); ?>
                </div>
                <div data-accordion-element-content class="meeek-accordion-content">
                    <ul class="meeeksaas-posts-list">
                    <?php 
                    if( $posts->have_posts() ) :
                        while( $posts->have_posts() ) : $posts->the_post();  
                            $title = ( mb_strlen( get_the_title() ) > 40 ) ? mb_substr( get_the_title(), 0, 29 ) . ' (...)' : get_the_title();
                            ?>
                            <li>
                                <a href="<?php the_permalink(); ?>" title="<?php the_title(); ?>">
                                    <?php echo get_the_post_thumbnail( get_the_ID(), 'thumbnail' ); ?>
                                    <?php echo $title; ?>
                                    <button class="btn btn-outline-secondary btn-sm"><?php esc_html_e('Read More', 'meeeksaas'); ?></button>
                                </a>
                            </li>
                            <?php  
                        endwhile;
                        wp_reset_postdata();
                    endif;
                    ?>
                    </ul>
                </div>
            </div>
        </div>
        <?php
    }
}
add_action('meeeksaas_bio_links_bottom', 'meeeksaas_blog_frontend', 10, 3);



// WooCommerce Products
function meeeksaas_woocommerce_frontend($type = '', $title = '', $pids = ''){
    if($type == 'woocommerce' && class_exists( 'WooCommerce' )){
        if (empty($pids)) {
            $pids = array();
        }

        $posts = new WP_Query( array( 
            'post_status' => 'publish', // if you don't want drafts to be returned
            'post_type' => 'product', // if you don't want drafts to be returned
            'post__in' => $pids, // if you don't want drafts to be returned
        ) );

        ?>
        <div class="meeek-bio-links-inner-dropdown meeek-accordion-card mb-3">
            <div class="meeek-accordion-card-inner">
                <div class="meeek-accordion-title" data-accordion-element-trigger>
                    <?php echo esc_html($title); ?>
                </div>
                <div data-accordion-element-content class="meeek-accordion-content">
                    <ul class="meeeksaas-posts-list meeeksaas-woocommerce-list">
                    <?php 
                    if( $posts->have_posts() ) :
                        while( $posts->have_posts() ) : $posts->the_post();  
                            $product = wc_get_product( get_the_ID() );
                            $title = ( mb_strlen( get_the_title() ) > 30 ) ? mb_substr( get_the_title(), 0, 29 ) . ' (...)' : get_the_title();
                            ?>
                            <li>
                                <a href="<?php the_permalink(); ?>" title="<?php the_title(); ?>">
                                    <?php echo get_the_post_thumbnail( get_the_ID(), 'thumbnail' ); ?>
                                    <?php echo $title; ?>
                                    (<?php echo $product->get_price_html(); ?>)
                                    <button class="btn btn-outline-secondary btn-sm"><?php esc_html_e('Buy Now', 'meeeksaas'); ?></button>
                                </a>
                            </li>
                            <?php  
                        endwhile;
                        wp_reset_postdata();
                    endif;
                    ?>
                    </ul>
                </div>
            </div>
        </div>
        <?php
    }
}
add_action('meeeksaas_bio_links_bottom', 'meeeksaas_woocommerce_frontend', 10, 3);
