<?php
if ( ! defined( 'ABSPATH' ) ) {
    exit; // Exit if accessed directly.
}
require_once('frontend.php');

if (!function_exists('meeeksaas_available_element_types')) {
    function meeeksaas_available_element_types(){
        $available_elements = array(
            'header',
            'image',
            'paypal',
            'venmo',
            'phone',
            'email',
            'button',
            'dropdown',
            'social-icon',
            'blog',
            'woocommerce',
            'vcard',
            'shortcode',
            'block',
        );

        return apply_filters('meeeksaas_available_elements', $available_elements);
    }
}


function meeeksaas_import_element() {

    check_ajax_referer('meeek_import_element', 'nonce');
    
    $type = $_POST['element_type'];
    $available_elements = meeeksaas_available_element_types();

    $filename = MEEEKSAAS_PLUGIN_ELEMENTS.$type.'.php';
    $filename_modules = MEEEKSAAS_PLUGIN_MODULES.$type.'/builder-element.php';
    $filename_child_theme_modules = get_stylesheet_directory().'/meeek-saas/modules/'.$type.'/builder-element.php';

    if (in_array($type, $available_elements)) {
        // find the element on the elements folder first
        if (file_exists($filename)) {
            require_once($filename);
        }elseif (file_exists($filename_modules)) {
            // find the file in modules
            require_once($filename_modules);
        }elseif (file_exists($filename_child_theme_modules)) {
            // find the file in the child theme
            require_once($filename_child_theme_modules);
        }
    }else{
        echo esc_html__('Upgrade your subscription', 'meeeksaas');
    }

    wp_die();
}
add_action( 'wp_ajax_meeeksaas_import_element', 'meeeksaas_import_element' );
add_action( 'wp_ajax_nopriv_meeeksaas_import_element', 'meeeksaas_import_element' );