<?php
if ( ! defined( 'ABSPATH' ) ) {
    exit; // Exit if accessed directly.
}

$settings = get_option('mt-saas-settings');
$restricted_elements = meeeksaas_get_restricted_elements();
?>
<div class="modal fade" id="meeeksaas_elements_modal" tabindex="-1" aria-labelledby="meeeksaas_elements_modalLabel" aria-hidden="true">
  <div class="modal-dialog modal-dialog-centered modal-dialog-scrollable modal-lg">
    <div class="modal-content">
      <div class="modal-header p-4">
        <h5 class="modal-title"><?php esc_html_e('Explore Elements', 'meeeksaas'); ?></h5>
        <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="<?php esc_attr_e('Close', 'meeeksaas'); ?>"></button>
      </div>

      <div class="modal-body p-4">
        <div class="row">
          <?php do_action('meeeksaas_before_elements_list'); ?>

          <?php if(!in_array('header', $restricted_elements)){ ?>
            <!-- Header -->
            <div class="list-inline col-md-6 mb-4">
              <div class="relative">
                <div class="list-inline-item align-middle">
                  <div class="feature-icon bg-header">
                    <i class="fas fa-heading"></i>
                  </div>
                </div>
                <div class="list-inline-item align-middle">
                  <h5 class="mb-0"><?php esc_html_e('Header', 'meeeksaas'); ?></h5>
                  <p class="m-0"><?php esc_html_e('A Text header as delimiter', 'meeeksaas'); ?></p>
                </div>
                <div class="list-inline-item align-middle float-end mt-2">
                  <?php do_action('meeeksaas_element_add_button', 'header'); ?>
                </div>
                <?php do_action('meeeksaas_builder_allow_header'); ?>
              </div>
            </div>
          <?php } ?>

          <?php if(!in_array('image', $restricted_elements)){ ?>
            <!-- image -->
            <div class="list-inline col-md-6 mb-4">
              <div class="relative">
                <div class="list-inline-item align-middle">
                  <div class="feature-icon bg-image">
                    <i class="fas fa-image"></i>
                  </div>
                </div>
                <div class="list-inline-item align-middle">
                  <h5 class="mb-0"><?php esc_html_e('Image', 'meeeksaas'); ?></h5>
                  <p class="m-0"><?php esc_html_e('A Simple Image Image', 'meeeksaas'); ?></p>
                </div>
                <div class="list-inline-item align-middle float-end mt-2">
                  <?php do_action('meeeksaas_element_add_button', 'image'); ?>
                </div>
                <?php do_action('meeeksaas_builder_allow_image'); ?>
              </div>
            </div>
          <?php } ?>

          <?php if(!in_array('paypal', $restricted_elements)){ ?>
            <!-- PayPal -->
            <div class="list-inline col-md-6 mb-4">
              <div class="relative">
                <div class="list-inline-item align-middle">
                  <div class="feature-icon bg-paypal">
                    <i class="fab fa-paypal"></i>
                  </div>
                </div>
                <div class="list-inline-item align-middle">
                  <h5 class="mb-0"><?php esc_html_e('PayPal', 'meeeksaas'); ?></h5>
                  <p class="m-0"><?php esc_html_e('A PayPal Donation Button', 'meeeksaas'); ?></p>
                </div>
                <div class="list-inline-item align-middle float-end mt-2">
                  <?php do_action('meeeksaas_element_add_button', 'paypal'); ?>
                </div>
                <?php do_action('meeeksaas_builder_allow_payment'); ?>
              </div>
            </div>
          <?php } ?>

          <?php if(!in_array('venmo', $restricted_elements)){ ?>
            <!-- Venmo -->
            <div class="list-inline col-md-6 mb-4">
              <div class="relative">
                <div class="list-inline-item align-middle">
                  <div class="feature-icon bg-venmo">
                    <svg width="15" viewBox="0 0 129 132" fill="none" xmlns="http://www.w3.org/2000/svg">
                    <path d="M120.811 0C125.773 7.91701 128.011 16.0716 128.011 26.3724C128.011 59.2269 98.9759 101.907 75.4109 131.877H21.5866L0 7.19336L47.129 2.87121L58.542 91.5915C69.2063 74.8097 82.3659 48.4375 82.3659 30.4571C82.3659 20.6153 80.6207 13.9117 77.8926 8.39206L120.811 0Z" fill="white"/></svg>
                  </div>
                </div>
                <div class="list-inline-item align-middle">
                  <h5 class="mb-0"><?php esc_html_e('Venmo', 'meeeksaas'); ?></h5>
                  <p class="m-0"><?php esc_html_e('A Venmo Donation Button', 'meeeksaas'); ?></p>
                </div>
                <div class="list-inline-item align-middle float-end mt-2">
                  <?php do_action('meeeksaas_element_add_button', 'venmo'); ?>
                </div>
                <?php do_action('meeeksaas_builder_allow_payment'); ?>
              </div>
            </div>
          <?php } ?>

          <?php if(!in_array('phone', $restricted_elements)){ ?>
            <!-- Phone -->
            <div class="list-inline col-md-6 mb-4">
              <div class="relative">
                <div class="list-inline-item align-middle">
                  <div class="feature-icon bg-phone">
                    <i class="fas fa-phone"></i>
                  </div>
                </div>
                <div class="list-inline-item align-middle">
                  <h5 class="mb-0"><?php esc_html_e('Phone', 'meeeksaas'); ?></h5>
                  <p class="m-0"><?php esc_html_e('A Phone Number Button', 'meeeksaas'); ?></p>
                </div>
                <div class="list-inline-item align-middle float-end mt-2">
                  <?php do_action('meeeksaas_element_add_button', 'phone'); ?>
                </div>
                <?php do_action('meeeksaas_builder_allow_phone'); ?>
              </div>
            </div>
          <?php } ?>

          <?php if(!in_array('email', $restricted_elements)){ ?>
            <!-- Email -->
            <div class="list-inline col-md-6 mb-4">
              <div class="relative">
                <div class="list-inline-item align-middle">
                  <div class="feature-icon bg-email">
                    <i class="far fa-envelope"></i>
                  </div>
                </div>
                <div class="list-inline-item align-middle">
                  <h5 class="mb-0"><?php esc_html_e('Email', 'meeeksaas'); ?></h5>
                  <p class="m-0"><?php esc_html_e('A Pre-Populated Email Link', 'meeeksaas'); ?></p>
                </div>
                <div class="list-inline-item align-middle float-end mt-2">
                  <?php do_action('meeeksaas_element_add_button', 'email'); ?>
                </div>
                <?php do_action('meeeksaas_builder_allow_email'); ?>
              </div>
            </div>
          <?php } ?>
          
          <?php if(!in_array('dropdown', $restricted_elements)){ ?>
            <!-- Dropdown -->
            <div class="list-inline col-md-6 mb-4">
              <div class="relative">
                <div class="list-inline-item align-middle">
                  <div class="feature-icon bg-dropdown">
                    <i class="far fa-caret-square-down"></i>
                  </div>
                </div>
                <div class="list-inline-item align-middle">
                  <h5 class="mb-0"><?php esc_html_e('Dropdown', 'meeeksaas'); ?></h5>
                  <p class="m-0"><?php esc_html_e('A Toggle-Ready Dropdown', 'meeeksaas'); ?></p>
                </div>
                <div class="list-inline-item align-middle float-end mt-2">
                  <?php do_action('meeeksaas_element_add_button', 'dropdown'); ?>
                </div>
                <?php do_action('meeeksaas_builder_allow_dropdown'); ?>
              </div>
            </div>
          <?php } ?>
          
          <?php if(!in_array('blog', $restricted_elements)){ ?>
            <!-- Blog -->
            <div class="list-inline col-md-6 mb-4">
              <div class="relative">
                <div class="list-inline-item align-middle">
                  <div class="feature-icon bg-blog">
                    <i class="fab fa-wordpress-simple"></i>
                  </div>
                </div>
                <div class="list-inline-item align-middle">
                  <h5 class="mb-0"><?php esc_html_e('Blog Articles', 'meeeksaas'); ?></h5>
                  <p class="m-0"><?php esc_html_e('A Blog Articles List', 'meeeksaas'); ?></p>
                </div>
                <div class="list-inline-item align-middle float-end mt-2">
                  <?php do_action('meeeksaas_element_add_button', 'blog'); ?>
                </div>
                <?php do_action('meeeksaas_builder_allow_blog'); ?>
              </div>
            </div>
          <?php } ?>
          
          <?php if(!in_array('shortcode', $restricted_elements)){ ?>
            <!-- shortcode -->
            <div class="list-inline col-md-6 mb-4">
              <div class="relative">
                <div class="list-inline-item align-middle">
                  <div class="feature-icon bg-shortcode">
                    <i class="fab fa-wordpress-simple"></i>
                  </div>
                </div>
                <div class="list-inline-item align-middle">
                  <h5 class="mb-0"><?php esc_html_e('WordPress Shortcode', 'meeeksaas'); ?></h5>
                  <p class="m-0"><?php esc_html_e('Add any shortcode to your page.', 'meeeksaas'); ?></p>
                </div>
                <div class="list-inline-item align-middle float-end mt-2">
                  <?php do_action('meeeksaas_element_add_button', 'shortcode'); ?>
                </div>
                <?php do_action('meeeksaas_builder_allow_shortcode'); ?>
              </div>
            </div>
          <?php } ?>
          
          <?php if(!in_array('block', $restricted_elements)){ ?>
            <!-- block -->
            <div class="list-inline col-md-6 mb-4">
              <div class="relative">
                <div class="list-inline-item align-middle">
                  <div class="feature-icon bg-block">
                    <i class="fas fa-code"></i>
                  </div>
                </div>
                <div class="list-inline-item align-middle">
                  <h5 class="mb-0"><?php esc_html_e('WordPress Block', 'meeeksaas'); ?></h5>
                  <p class="m-0"><?php esc_html_e('Add any block code to your page.', 'meeeksaas'); ?></p>
                </div>
                <div class="list-inline-item align-middle float-end mt-2">
                  <?php do_action('meeeksaas_element_add_button', 'block'); ?>
                </div>
                <?php do_action('meeeksaas_builder_allow_block'); ?>
              </div>
            </div>
          <?php } ?>
          
          <?php if(!in_array('woocommerce', $restricted_elements)){ ?>
            <!-- WooCommerce -->
            <div class="list-inline col-md-6 mb-4">
              <div class="relative">
                <div class="list-inline-item align-middle">
                  <div class="feature-icon bg-woocommerce">
                    <img src="<?php echo MEEEKSAAS_PLUGIN_URL.'assets/images/woocommerce.svg'; ?>" alt="wooocommerce" />
                  </div>
                </div>
                <div class="list-inline-item align-middle">
                  <h5 class="mb-0"><?php esc_html_e('Products', 'meeeksaas'); ?></h5>
                  <p class="m-0"><?php esc_html_e('An WooCommerce Products List', 'meeeksaas'); ?></p>
                </div>
                <div class="list-inline-item align-middle float-end mt-2">
                  <?php do_action('meeeksaas_element_add_button', 'woocommerce'); ?>
                </div>
                <?php do_action('meeeksaas_builder_allow_woocommerce'); ?>
              </div>
            </div>
          <?php } ?>
          
          <?php if(!in_array('vcard', $restricted_elements)){ ?>
            <!-- vcard -->
            <div class="list-inline col-md-6 mb-4">
              <div class="relative">
                <div class="list-inline-item align-middle">
                  <div class="feature-icon bg-vcard">
                    <i class="far fa-address-book"></i>
                  </div>
                </div>
                <div class="list-inline-item align-middle">
                  <h5 class="mb-0"><?php esc_html_e('vCard QR', 'meeeksaas'); ?></h5>
                  <p class="m-0"><?php esc_html_e('Add me to your contacts vCard.', 'meeeksaas'); ?></p>
                </div>
                <div class="list-inline-item align-middle float-end mt-2">
                  <?php do_action('meeeksaas_element_add_button', 'vcard'); ?>
                </div>
                <?php do_action('meeeksaas_builder_allow_vcard'); ?>
              </div>
            </div>
          <?php } ?>

          <?php do_action('meeeksaas_after_elements_list'); ?>
        </div>
      </div>

      <div class="modal-footer text-left">
        <button type="button" class="btn btn-secondary" data-bs-dismiss="modal"><?php esc_html_e('Close', 'meeeksaas'); ?></button>
      </div>
    </div>
  </div>
</div>