<?php
if ( ! defined( 'ABSPATH' ) ) {
    exit; // Exit if accessed directly.
}
?>
<div class="modal fade" id="meeeksaas_seo_modal" tabindex="-1" aria-labelledby="meeeksaas_seo_modalLabel" aria-hidden="true">
  <div class="modal-dialog modal-dialog-centered modal-dialog-scrollable modal-lg">
    <div class="modal-content">
      <div class="modal-header p-4">
        <h5 class="modal-title"><?php esc_html_e('SEO Settings', 'meeeksaas'); ?></h5>
        <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="<?php esc_attr_e('Close', 'meeeksaas'); ?>"></button>
      </div>

      <div class="modal-body p-4">
        <label for="basic-url" class="form-label"><?php esc_html_e('Your Bio Page Title', 'meeeksaas'); ?></label>
        <div class="input-group mb-3">
          <span class="input-group-text" id="seo_page_title"><?php esc_html_e('Title', 'meeeksaas'); ?></span>
          <input type="text" class="form-control" aria-describedby="seo_page_title" name="seo_page_title" value="<?php echo esc_attr($seo_page_title); ?>" />
        </div>
        <label for="basic-url" class="form-label"><?php esc_html_e('Your Bio Page URL', 'meeeksaas'); ?></label>
        
        <div class="input-group mb-3">
          <span class="input-group-text" id="seo_page_slug"><?php echo get_site_url(); ?></span>
          <input type="text" class="form-control seo_page_slug" aria-describedby="seo_page_slug" name="seo_page_slug" value="<?php echo esc_attr($seo_page_slug); ?>" />
          
          <?php 
          if(!meeeksaas_user_has_benefit('allow_seo_clean_url')){ ?>
            <div class="relative input-group-text meeek-seo-clean-url">
              <?php echo esc_attr($seo_page_slug_id); ?> <i data-bs-toggle="tooltip" data-bs-placement="top" data-bs-title="<?php esc_attr_e('Disable this link slug by upgrading your subscription.', 'meeeksaas'); ?>" class="fas fa-question-circle"></i>
              <?php do_action('meeeksaas_builder_allow_seo_clean_url'); ?>
            </div>
          
            <input type="hidden" name="seo_page_slug_id" value="<?php echo esc_attr($seo_page_slug_id); ?>" />
          <?php } ?>
        </div>
        <div class="meeeksaas-page-slug-status"></div>

        <?php 
          echo meeeksaas_checkbox('seo_indexable', 'seo_indexable', esc_html__('Prevent indexing', 'meeeksaas'), $seo_indexable, 'allow_seo_prevent_index');
        ?>
        <p><?php esc_html_e('By checking the Prevent indexing option, this page will stop being indexed by search engines.', 'meeeksaas'); ?></p>
      </div>

      <div class="modal-footer text-left">
        <button type="button" class="btn btn-secondary" data-bs-dismiss="modal"><?php esc_html_e('Close', 'meeeksaas'); ?></button>
      </div>
    </div>
  </div>
</div>