<?php
if ( ! defined( 'ABSPATH' ) ) {
    exit; // Exit if accessed directly.
}
?>
<div class="modal fade" id="meeeksaas_skins_modal" tabindex="-1" aria-labelledby="meeeksaas_skins_modalLabel" aria-hidden="true">
  <div class="modal-dialog modal-dialog-centered modal-dialog-scrollable modal-lg">
    <div class="modal-content">
      <div class="modal-header p-4">
        <h5 class="modal-title"><?php echo esc_html__('Available Templates', 'meeeksaas'); ?></h5>
        <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="<?php echo esc_attr__('Close', 'meeeksaas'); ?>"></button>
      </div>

      <div class="modal-body p-4">
        <div class="row">

          <?php do_action('meeeksaas_builder_before_premade_templates'); ?>
          <?php 
            $settings = get_option('mt-saas-settings');
            $meeeksaas_default_templates = 'off';
            if ($settings) {
                $meeeksaas_default_templates = ((array_key_exists('meeeksaas_default_templates', $settings))?$settings['meeeksaas_default_templates']:"off");
            }
          ?>

          <?php if($meeeksaas_default_templates == 'off'){ ?>
            <div class="list-inline col-md-6 mb-4">
              <div class="relative">
                <img src="<?php echo MEEEKSAAS_PLUGIN_URL; ?>assets/images/templates/demo_00_vertical.jpg" alt="<?php esc_attr_e('Template', 'meeeksaas'); ?>" />
                <?php do_action('meeeksaas_builder_allow_templates'); ?>
                <?php do_action('meeeksaas_builder_allow_templates_importer', 'v1'); ?>
              </div>
            </div>
            <div class="list-inline col-md-6 mb-4">
              <div class="relative">
                <img src="<?php echo MEEEKSAAS_PLUGIN_URL; ?>assets/images/templates/demo_01_vertical.jpg" alt="<?php esc_attr_e('Template', 'meeeksaas'); ?>" />
                <?php do_action('meeeksaas_builder_allow_templates'); ?>
                <?php do_action('meeeksaas_builder_allow_templates_importer', 'v2'); ?>
              </div>
            </div>
            <div class="list-inline col-md-6 mb-4">
              <div class="relative">
                <img src="<?php echo MEEEKSAAS_PLUGIN_URL; ?>assets/images/templates/demo_02_vertical.jpg" alt="<?php esc_attr_e('Template', 'meeeksaas'); ?>" />
                <?php do_action('meeeksaas_builder_allow_templates'); ?>
                <?php do_action('meeeksaas_builder_allow_templates_importer', 'v3'); ?>
              </div>
            </div>
            <div class="list-inline col-md-6 mb-4">
              <div class="relative">
                <img src="<?php echo MEEEKSAAS_PLUGIN_URL; ?>assets/images/templates/demo_03_vertical.jpg" alt="<?php esc_attr_e('Template', 'meeeksaas'); ?>" />
                <?php do_action('meeeksaas_builder_allow_templates'); ?>
                <?php do_action('meeeksaas_builder_allow_templates_importer', 'v4'); ?>
              </div>
            </div>
            <div class="list-inline col-md-6 mb-4">
              <div class="relative">
                <img src="<?php echo MEEEKSAAS_PLUGIN_URL; ?>assets/images/templates/demo_04_vertical.jpg" alt="<?php esc_attr_e('Template', 'meeeksaas'); ?>" />
                <?php do_action('meeeksaas_builder_allow_templates'); ?>
                <?php do_action('meeeksaas_builder_allow_templates_importer', 'v5'); ?>
              </div>
            </div>
            <div class="list-inline col-md-6 mb-4">
              <div class="relative">
                <img src="<?php echo MEEEKSAAS_PLUGIN_URL; ?>assets/images/templates/demo_05_vertical.jpg" alt="<?php esc_attr_e('Template', 'meeeksaas'); ?>" />
                <?php do_action('meeeksaas_builder_allow_templates'); ?>
                <?php do_action('meeeksaas_builder_allow_templates_importer', 'v6'); ?>
              </div>
            </div>
            <div class="list-inline col-md-6 mb-4">
              <div class="relative">
                <img src="<?php echo MEEEKSAAS_PLUGIN_URL; ?>assets/images/templates/demo_06_vertical.jpg" alt="<?php esc_attr_e('Template', 'meeeksaas'); ?>" />
                <?php do_action('meeeksaas_builder_allow_templates'); ?>
                <?php do_action('meeeksaas_builder_allow_templates_importer', 'v7'); ?>
              </div>
            </div>
            <div class="list-inline col-md-6 mb-4">
              <div class="relative">
                <img src="<?php echo MEEEKSAAS_PLUGIN_URL; ?>assets/images/templates/demo_07_vertical.jpg" alt="<?php esc_attr_e('Template', 'meeeksaas'); ?>" />
                <?php do_action('meeeksaas_builder_allow_templates'); ?>
                <?php do_action('meeeksaas_builder_allow_templates_importer', 'v8'); ?>
              </div>
            </div>
            <div class="list-inline col-md-6 mb-4">
              <div class="relative">
                <img src="<?php echo MEEEKSAAS_PLUGIN_URL; ?>assets/images/templates/demo_09_vertical.jpg" alt="<?php esc_attr_e('Template', 'meeeksaas'); ?>" />
                <?php do_action('meeeksaas_builder_allow_templates'); ?>
                <?php do_action('meeeksaas_builder_allow_templates_importer', 'v9'); ?>
              </div>
            </div>
            <div class="list-inline col-md-6 mb-4">
              <div class="relative">
                <img src="<?php echo MEEEKSAAS_PLUGIN_URL; ?>assets/images/templates/demo_10_vertical.jpg" alt="<?php esc_attr_e('Template', 'meeeksaas'); ?>" />
                <?php do_action('meeeksaas_builder_allow_templates'); ?>
                <?php do_action('meeeksaas_builder_allow_templates_importer', 'v10'); ?>
              </div>
            </div>
          <?php } ?>

          <?php do_action('meeeksaas_builder_after_premade_templates'); ?>

        </div>
      </div>
    </div>
  </div>
</div>