<?php
if ( ! defined( 'ABSPATH' ) ) {
    exit; // Exit if accessed directly.
}

function meeeksaas_custom_login_register_customizer($wp_customize) {
    if (class_exists('Meeek')) {
        // Add Panel
        $wp_customize->add_panel('meeeksaas_login_register_panel', array(
            'title' => __('Login/Register Page', 'meeeksaas'),
            'priority' => 30,
        ));

        // Add Section
        $wp_customize->add_section('meeeksaas_login_register_settings_section', array(
            'title' => __('Settings', 'meeeksaas'),
            'panel' => 'meeeksaas_login_register_panel',
        ));

        // Title
        $wp_customize->add_setting('meeeksaas_login_register_title', array(
            'default' => 'We focus on growing your link in bio',
            'sanitize_callback' => 'sanitize_text_field',
        ));
        $wp_customize->add_control('meeeksaas_login_register_title', array(
            'label' => __('Title', 'meeeksaas'),
            'section' => 'meeeksaas_login_register_settings_section',
            'type' => 'text',
        ));

        // Subtitle
        $wp_customize->add_setting('meeeksaas_login_register_subtitle', array(
            'default' => 'More Traffic. More Clicks. More Tools.',
            'sanitize_callback' => 'sanitize_text_field',
        ));
        $wp_customize->add_control('meeeksaas_login_register_subtitle', array(
            'label' => __('Subtitle', 'meeeksaas'),
            'section' => 'meeeksaas_login_register_settings_section',
            'type' => 'text',
        ));

        // Site Name
        $wp_customize->add_setting('meeeksaas_login_register_site_name', array(
            'default' => get_bloginfo( 'name' ),
            'sanitize_callback' => 'sanitize_text_field',
        ));
        $wp_customize->add_control('meeeksaas_login_register_site_name', array(
            'label' => __('Site Name', 'meeeksaas'),
            'section' => 'meeeksaas_login_register_settings_section',
            'type' => 'text',
        ));


        // Add Enable/Disable Switch (Checkbox)
        $wp_customize->add_setting('meeeksaas_login_register_testimonial_status', array(
            'default' => true,
            'sanitize_callback' => 'rest_sanitize_boolean',
        ));

        $wp_customize->add_control('meeeksaas_login_register_testimonial_status', array(
            'label' => __('Enable Testimonial', 'your-textdomain'),
            'section' => 'meeeksaas_login_register_settings_section',
            'type' => 'checkbox',
        ));
        // Testimonial Content
        $wp_customize->add_setting('meeeksaas_login_register_testimonial_content', array(
            'default' => 'It is exactly what I was looking for. The tool not only engages our site visitors by providing them with the right answers to their questions, but it also effectively collects their information. As a result, we are seeing a significant increase in the number of leads generated',
            'sanitize_callback' => 'sanitize_textarea_field',
        ));
        $wp_customize->add_control('meeeksaas_login_register_testimonial_content', array(
            'label' => __('Testimonial Content', 'meeeksaas'),
            'section' => 'meeeksaas_login_register_settings_section',
            'type' => 'textarea',
            'active_callback' => function() use ($wp_customize) {
                return get_theme_mod('meeeksaas_login_register_testimonial_status', true);
            },
        ));

        // Testimonial From
        $wp_customize->add_setting('meeeksaas_login_register_testimonial_from', array(
            'default' => 'Austin Johnson',
            'sanitize_callback' => 'sanitize_text_field',
        ));
        $wp_customize->add_control('meeeksaas_login_register_testimonial_from', array(
            'label' => __('Testimonial From', 'meeeksaas'),
            'section' => 'meeeksaas_login_register_settings_section',
            'type' => 'text',
            'active_callback' => function() use ($wp_customize) {
                return get_theme_mod('meeeksaas_login_register_testimonial_status', true);
            },
        ));

        // Testimonial Job
        $wp_customize->add_setting('meeeksaas_login_register_testimonial_job', array(
            'default' => 'CEO - @'.get_bloginfo( 'name' ),
            'sanitize_callback' => 'sanitize_text_field',
        ));
        $wp_customize->add_control('meeeksaas_login_register_testimonial_job', array(
            'label' => __('Testimonial Job', 'meeeksaas'),
            'section' => 'meeeksaas_login_register_settings_section',
            'type' => 'text',
            'active_callback' => function() use ($wp_customize) {
                return get_theme_mod('meeeksaas_login_register_testimonial_status', true);
            },
        ));


        // Add Section
        $wp_customize->add_section('meeeksaas_login_register_styling_section', array(
            'title' => __('Styling', 'meeeksaas'),
            'panel' => 'meeeksaas_login_register_panel',
        ));

        // Add Color Picker Control
        $wp_customize->add_setting('meeeksaas_login_register_texts_color', array(
            'default' => '#000000',
            'sanitize_callback' => 'sanitize_hex_color',
        ));

        $wp_customize->add_control(new WP_Customize_Color_Control($wp_customize, 'meeeksaas_login_register_texts_color', array(
            'label' => __('Texts Color', 'your-textdomain'),
            'section' => 'meeeksaas_login_register_styling_section',
        )));

        // Background Image
        $wp_customize->add_setting('meeeksaas_login_register_bg_image', array(
            'default' => '',
            'sanitize_callback' => 'esc_url_raw',
        ));
        $wp_customize->add_control(new WP_Customize_Image_Control($wp_customize, 'meeeksaas_login_register_bg_image', array(
            'label' => __('Background Image', 'your-textdomain'),
            'section' => 'meeeksaas_login_register_styling_section',
        )));
    }
}
add_action('customize_register', 'meeeksaas_custom_login_register_customizer');
