<?php
if ( ! defined( 'ABSPATH' ) ) {
    exit; // Exit if accessed directly.
}


function meeeksaas_link_toggles_footer($button){
    ?>
    <div class="meeeksaas-link-toggles-group">
        <div class="meeeksaas-link-toggles-buttons">
            <?php do_action('meeeksaas_link_toggles_buttons', $button); ?>
        </div>
        <div class="meeeksaas-link-toggles-content">
            <?php do_action('meeeksaas_link_toggles_content', $button); ?>
        </div>
    </div>
    <?php
}
add_action('meeeksaas_builder_after_element_fields', 'meeeksaas_link_toggles_footer');


function meeeksaas_toggle_buttons($button){
    $btn_schedule_id = uniqid('-');
    $checked_schedule_status = $checked_schedule_active = $schedule_status = '';
    $button_type =     ((array_key_exists('btn_type', $button))?$button['btn_type']:'btn_button');

    if ($button) {
        $schedule_status = ((array_key_exists('btn_schedule_status', $button))?$button['btn_schedule_status']:'');
        if (is_array($schedule_status)) {
            if ($schedule_status[0] == 'on') {
                $checked_schedule_status = 'checked';
                $checked_schedule_active = 'btn-toggler-active';
            }
        }
    }
    ?>
    <div class="meeeksaas-options-toggler meeeksaas-schedule-btn" data-id="btn-schedule">
        <input class="btn_schedule_input" <?php echo $checked_schedule_status; ?> name="btn_schedule_status" type="checkbox" id="btn_schedule<?php echo esc_attr($btn_schedule_id); ?>" autocomplete="off" />
        <label data-bs-toggle="tooltip" data-bs-placement="top" data-bs-title="<?php esc_attr_e('Schedule', 'meeeksaas'); ?>" for="btn_schedule<?php echo esc_attr($btn_schedule_id); ?>" class="btn btn-outline-secondary mt-2 mb-2 <?php echo $checked_schedule_active; ?>"><i class="far fa-clock"></i></label>
    </div>

    <?php 
        if ($button_type == 'btn_button') {
            $btn_label_id = uniqid('-');
            $checked_label_status = $checked_label_active = $label_status = '';
            if ($button) {
                $label_status =     ((array_key_exists('btn_label_status', $button))?$button['btn_label_status']:'');
                if (is_array($label_status)) {
                    if ($label_status[0] == 'on') {
                        $checked_label_status = 'checked';
                        $checked_label_active = 'btn-toggler-active';
                    }
                }
            }
            ?>
            <div class="meeeksaas-options-toggler meeeksaas-label-btn" data-id="btn-label">
                <input class="btn_label_input" <?php echo $checked_label_status; ?> name="btn_label_status" type="checkbox" id="btn_label<?php echo esc_attr($btn_label_id); ?>" autocomplete="off" />
                <label data-bs-toggle="tooltip" data-bs-placement="top" data-bs-title="<?php esc_attr_e('Button Label', 'meeeksaas'); ?>" for="btn_label<?php echo esc_attr($btn_label_id); ?>" class="btn btn-outline-secondary mt-2 mb-2 <?php echo $checked_label_active; ?>"><i class="fas fa-tag"></i></label>
            </div>
        <?php } ?>

    <?php 
        $btn_sponsored_id = uniqid('-');
        $checked_sponsored_status = $checked_sponsored_active = $sponsored_status = '';
        if ($button) {
            $sponsored_status =     ((array_key_exists('btn_sponsored', $button))?$button['btn_sponsored']:'');
            if (is_array($sponsored_status)) {
                if ($sponsored_status[0] == 'on') {
                    $checked_sponsored_status = 'checked';
                    $checked_sponsored_active = 'btn-toggler-active';
                }
            }
        }
    ?>
    <div class="meeeksaas-options-toggler meeeksaas-sponsored-btn" data-id="">
        <input class="btn_label_input" <?php echo $checked_sponsored_status; ?> name="btn_sponsored" type="checkbox" id="btn_label<?php echo esc_attr($btn_sponsored_id); ?>" autocomplete="off" />
        <label data-bs-toggle="tooltip" data-bs-placement="top" data-bs-title="<?php esc_attr_e('Sponsored Link', 'meeeksaas'); ?>" for="btn_label<?php echo esc_attr($btn_sponsored_id); ?>" class="btn btn-outline-secondary mt-2 mb-2 <?php echo $checked_sponsored_active; ?>"><i class="fas fa-ad"></i></label>
    </div>

    <?php 
        $btn_newtab_id = uniqid('-');
        $checked_newtab_status = $checked_newtab_active = $newtab_status = '';
        if ($button) {
            $newtab_status =     ((array_key_exists('btn_target_new_tab', $button))?$button['btn_target_new_tab']:'');
            if (is_array($newtab_status)) {
                if ($newtab_status[0] == 'on') {
                    $checked_newtab_status = 'checked';
                    $checked_newtab_active = 'btn-toggler-active';
                }
            }
        }
    ?>
    <div class="meeeksaas-options-toggler meeeksaas-newtab-btn" data-id="">
        <input class="btn_label_input" <?php echo $checked_newtab_status; ?> name="btn_target_new_tab" type="checkbox" id="btn_label<?php echo esc_attr($btn_newtab_id); ?>" autocomplete="off" />
        <label data-bs-toggle="tooltip" data-bs-placement="top" data-bs-title="<?php esc_attr_e('Open in New Tab', 'meeeksaas'); ?>" for="btn_label<?php echo esc_attr($btn_newtab_id); ?>" class="btn btn-outline-secondary mt-2 mb-2 <?php echo $checked_newtab_active; ?>"><i class="fas fa-external-link-alt"></i></label>
    </div>

    <?php 
        if ($button_type == 'btn_button') {
            $btn_linkstyle_id = uniqid('-');
            $checked_linkstyle_status = $checked_linkstyle_active = $linkstyle_status = '';
            if ($button) {
                $linkstyle_status =     ((array_key_exists('btn_linkstyle_status', $button))?$button['btn_linkstyle_status']:'');
                if (is_array($linkstyle_status)) {
                    if ($linkstyle_status[0] == 'on') {
                        $checked_linkstyle_status = 'checked';
                        $checked_linkstyle_active = 'btn-toggler-active';
                    }
                }
            }
            ?>
            <div class="meeeksaas-options-toggler meeeksaas-linkstyle-btn" data-id="btn-linkstyle">
                <input class="btn_linkstyle_input" <?php echo $checked_linkstyle_status; ?> name="btn_linkstyle_status" type="checkbox" id="btn_linkstyle<?php echo esc_attr($btn_linkstyle_id); ?>" autocomplete="off" />
                <label data-bs-toggle="tooltip" data-bs-placement="top" data-bs-title="<?php esc_attr_e('Custom Link Style', 'meeeksaas'); ?>" for="btn_linkstyle<?php echo esc_attr($btn_linkstyle_id); ?>" class="btn btn-outline-secondary mt-2 mb-2 <?php echo $checked_linkstyle_active; ?>"><i class="fas fa-palette"></i></label>
            </div>
        <?php } ?>

    <?php 
        $btn_nsfw_id = uniqid('-');
        $checked_nsfw_status = $checked_nsfw_active = $nsfw_status = '';
        if ($button) {
            $nsfw_status =     ((array_key_exists('btn_nsfw', $button))?$button['btn_nsfw']:'');
            if (is_array($nsfw_status)) {
                if ($nsfw_status[0] == 'on') {
                    $checked_nsfw_status = 'checked';
                    $checked_nsfw_active = 'btn-toggler-active';
                }
            }
        }
    ?>
    <div class="meeeksaas-options-toggler meeeksaas-nsfw-btn" data-id="">
        <input class="btn_label_input" <?php echo $checked_nsfw_status; ?> name="btn_nsfw" type="checkbox" id="btn_label<?php echo esc_attr($btn_nsfw_id); ?>" autocomplete="off" />
        <label data-bs-toggle="tooltip" data-bs-placement="top" data-bs-title="<?php esc_attr_e('Link', 'meeeksaas'); ?>" for="btn_label<?php echo esc_attr($btn_nsfw_id); ?>" class="btn btn-outline-secondary mt-2 mb-2 <?php echo $checked_nsfw_active; ?>">NSFW</label>
    </div><?php 


}
add_action('meeeksaas_link_toggles_buttons', 'meeeksaas_toggle_buttons');


/**
* Builder: Add schedule after any element type Element
* 
*/
function meeeksaas_toggle_form_components($button){
    $checked_schedule_status = $schedule_status = $start_date = $end_date = $timezone = '';
    $button_type =     ((array_key_exists('btn_type', $button))?$button['btn_type']:'btn_button');
    if ($button) {
        $schedule_status =     ((array_key_exists('btn_schedule_status', $button))?$button['btn_schedule_status']:'');
        $start_date =     ((array_key_exists('btn_schedule_date_start', $button))?$button['btn_schedule_date_start']:'');
        $end_date =       ((array_key_exists('btn_schedule_date_end', $button))?$button['btn_schedule_date_end']:'');
        $timezone =       ((array_key_exists('btn_schedule_date_timezone', $button))?$button['btn_schedule_date_timezone']:'Europe/London');
        if (is_array($schedule_status)) {
            if ($schedule_status[0] == 'on') {
                $checked_schedule_status = 'checked';
            }
        }
    }
    ?>
    <div class="meeeksaas-schedule-group <?php if ($checked_schedule_status != 'checked'){echo 'meeeksaas-hidden';} ?>" data-id="btn-schedule">
        <fieldset class="border p-2 relative">
            <legend class="float-none w-auto"><i class="far fa-clock"></i> <?php esc_html_e('Schedule:', 'meeeksaas'); ?></legend>
            <div class="row">
                <?php 
                    echo meeeksaas_input('text', 'btn_schedule_date_start', $start_date, esc_html__('Start Time', 'meeeksaas'), 'btn_schedule_date_start', false, 'col-md-6 meeek-datetime-picker');
                    echo meeeksaas_input('text', 'btn_schedule_date_end', $end_date, esc_html__('End Time', 'meeeksaas'), 'btn_schedule_date_end', false, 'col-md-6 meeek-datetime-picker');
                    echo meeeksaas_timezone_select('btn_schedule_date_timezone', $timezone, esc_html__('Timezone', 'meeeksaas'), 'btn_schedule_date_timezone', 'col-md-12' );
                ?>
            </div>
            <?php do_action('meeeksaas_builder_allow_schedule_link'); ?>
        </fieldset>
    </div>

    <?php 
    if ($button_type == 'btn_button') {
        $checked_label_status = $label_status = $label_text = $btn_label_background = $btn_label_color = '';
        if ($button) {
            $label_status =     ((array_key_exists('btn_label_status', $button))?$button['btn_label_status']:'');
            $label_text =     ((array_key_exists('label_text', $button))?$button['label_text']:'');
            $btn_label_background =     ((array_key_exists('btn_label_background', $button))?$button['btn_label_background']:'');
            $btn_label_color =       ((array_key_exists('btn_label_color', $button))?$button['btn_label_color']:'');
            if (is_array($label_status)) {
                if ($label_status[0] == 'on') {
                    $checked_label_status = 'checked';
                }
            }
        } ?>
        <div class="meeeksaas-btn-label-group <?php if ($checked_label_status != 'checked'){echo 'meeeksaas-hidden';} ?>" data-id="btn-label">
            <fieldset class="border p-2 relative">
                <legend class="float-none w-auto"><i class="fas fa-tag"></i> <?php esc_html_e('Button Label:', 'meeeksaas'); ?></legend>
                <div class="row">
                    <?php 
                        echo meeeksaas_input('text', 'label_text', $label_text, esc_html__('Label Text', 'meeeksaas'), 'meeeksaas_label_text', false, 'col-md-4');
                        echo meeeksaas_colorpicker('btn_label_background', $btn_label_background, esc_html__('Label Background', 'meeeksaas'), 'btn_label_background', 'col-md-4');
                        echo meeeksaas_colorpicker('btn_label_color', $btn_label_color, esc_html__('Label Color', 'meeeksaas'), 'btn_label_color', 'col-md-4');
                    ?>
                   
                    <?php do_action('meeeksaas_builder_after_button_label', array('btn_type' => 'button-label')); ?>
                </div>
                <?php do_action('meeeksaas_builder_allow_button_label'); ?>
            </fieldset>
        </div>
    <?php } ?>

    <?php 
    if ($button_type == 'btn_button') {
        $checked_linkstyle_status = $linkstyle_status = $btn_link_background = $btn_link_color = $btn_link_border = $btn_link_background_hover = $btn_link_color_hover = $btn_link_border_hover = '';
        if ($button) {
            $linkstyle_status =     ((array_key_exists('btn_schedule_status', $button))?$button['btn_schedule_status']:'');
            $btn_link_background =     ((array_key_exists('btn_link_background', $button))?$button['btn_link_background']:'');
            $btn_link_color =       ((array_key_exists('btn_link_color', $button))?$button['btn_link_color']:'');
            $btn_link_border =       ((array_key_exists('btn_link_border', $button))?$button['btn_link_border']:'');
            $btn_link_background_hover =     ((array_key_exists('btn_link_background_hover', $button))?$button['btn_link_background_hover']:'');
            $btn_link_color_hover =       ((array_key_exists('btn_link_color_hover', $button))?$button['btn_link_color_hover']:'');
            $btn_link_border_hover =       ((array_key_exists('btn_link_border_hover', $button))?$button['btn_link_border_hover']:'');
            if (is_array($linkstyle_status)) {
                if ($linkstyle_status[0] == 'on') {
                    $checked_linkstyle_status = 'checked';
                }
            }
        } ?>
        <div class="meeeksaas-btn-linkstyle-group <?php if ($checked_linkstyle_status != 'checked'){echo 'meeeksaas-hidden';} ?>" data-id="btn-linkstyle">
            <fieldset class="border p-2 relative">
                <legend class="float-none w-auto"><i class="fas fa-palette"></i> <?php esc_html_e('Link Custom Style:', 'meeeksaas'); ?></legend>
                <div class="row">
                    <div class="col-md-6">
                        <div class="row">
                            <?php 
                                echo meeeksaas_colorpicker('btn_link_background', $btn_link_background, esc_html__('Link Background', 'meeeksaas'), 'btn_link_background', 'col-md-12 col-xs-12');
                                echo meeeksaas_colorpicker('btn_link_color', $btn_link_color, esc_html__('Link Color', 'meeeksaas'), 'btn_link_color', 'col-md-12 col-xs-12');
                                echo meeeksaas_colorpicker('btn_link_border', $btn_link_border, esc_html__('Border Color', 'meeeksaas'), 'btn_link_color', 'col-md-12 col-xs-12');
                            ?>
                        </div>
                    </div>
                    <div class="col-md-6">
                        <div class="row">
                            <?php 
                                echo meeeksaas_colorpicker('btn_link_background_hover', $btn_link_background_hover, esc_html__('Link Background (Hover)', 'meeeksaas'), 'btn_link_background_hover', 'col-md-12 col-xs-12');
                                echo meeeksaas_colorpicker('btn_link_color_hover', $btn_link_color_hover, esc_html__('Link Color (Hover)', 'meeeksaas'), 'btn_link_color_hover', 'col-md-12 col-xs-12');
                                echo meeeksaas_colorpicker('btn_link_border_hover', $btn_link_border_hover, esc_html__('Border Color (Hover)', 'meeeksaas'), 'btn_link_border_hover', 'col-md-12 col-xs-12');
                            ?>
                        </div>
                    </div>
                </div>
                <?php do_action('meeeksaas_builder_allow_button_linkstyle'); ?>
            </fieldset>
        </div>
    <?php } ?>

    <?php 
}
add_action('meeeksaas_link_toggles_content', 'meeeksaas_toggle_form_components');
