<?php
if ( ! defined( 'ABSPATH' ) ) {
    exit; // Exit if accessed directly.
}

/**
* Package Benefits list override (from the SaaS module)
*
*/
if (!function_exists('meeeksaas_benefits_list_override')) {
    function meeeksaas_benefits_list_override(){
        
        $list['allow_branding']             = esc_html__('Hide Brand Logo','meeeksaas');
        $list['allow_bg']                   = esc_html__('Button Custom Styles','meeeksaas');
        $list['allow_body_bg']              = esc_html__('Page background image','meeeksaas');
        $list['allow_button_label']         = esc_html__('Button Label Bubble','meeeksaas');
        $list['allow_seo_clean_url']        = esc_html__('Custom Links (Clean URL)','meeeksaas');
        $list['allow_seo_clean_title']      = esc_html__('Custom Page Title (No branding)','meeeksaas');
        $list['allow_templates']            = esc_html__('Extended Templates','meeeksaas');
        $list['allow_bio']                  = esc_html__('Custom Profile Picture & Title + Bio Description','meeeksaas');
        $list['allow_seo']                  = esc_html__('SEO Settings','meeeksaas');
        $list['allow_seo_prevent_index']    = esc_html__('Prevent Indexing','meeeksaas');
        
        $list['allow_unlimited_links']      = esc_html__('Unlimited Links','meeeksaas'); //included
        $list['allow_social_icons']         = esc_html__('Social Media Icons','meeeksaas'); //included
        $list['allow_qr']                   = esc_html__('QR Code','meeeksaas'); //included

        // elements
        $list['allow_payment']              = esc_html__('Payments with PayPal & Venmo','meeeksaas');
        $list['allow_header']              = esc_html__('Headers','meeeksaas');
        $list['allow_image']              = esc_html__('Image Element','meeeksaas');
        $list['allow_email']              = esc_html__('Email Element','meeeksaas');
        $list['allow_dropdown']             = esc_html__('Dropdown Button Type','meeeksaas');
        $list['allow_youtube']              = esc_html__('YouTube Videos','meeeksaas');
        $list['allow_spotify']              = esc_html__('Spotify Embeds','meeeksaas');
        $list['allow_phone']                = esc_html__('Phone/WhatsApp Button','meeeksaas');
        $list['allow_twitter']              = esc_html__('Twitter Embed','meeeksaas');
        $list['allow_facebook']             = esc_html__('Facebook Embed','meeeksaas');
        $list['allow_tiktok']               = esc_html__('TikTok Video Embeds','meeeksaas');
        $list['allow_woocommerce'] = esc_html__('WooCommerce Products','meeeksaas');
        $list['allow_blog']        = esc_html__('Blog Articles','meeeksaas');
        $list['allow_vcard']                = esc_html__('vCard QR','meeeksaas'); //included
        $list['allow_g_analytiics']         = esc_html__('Google Analytics','meeeksaas'); //included
        $list['allow_metrics']         = esc_html__('Page Metrics','meeeksaas'); //included
        $list['allow_shortcode']         = esc_html__('WordPress Shortcodes','meeeksaas'); //included
        $list['allow_block']         = esc_html__('WordPress Blocks','meeeksaas'); //included

        // Other (included in all packages)
        $list['allow_support']              = esc_html__('Support','meeeksaas');
        $list['allow_2step_auth']           = esc_html__('2 Step Authentication','meeeksaas');

        // newsletter module/addon
        if (function_exists('meeeksaas_newsletter_element')) {
            $list['allow_newsletter']             = esc_html__('Newsletter Subscription Forms','meeeksaas');
        }
        // booking module/addon
        if (function_exists('meeeksaas_booking_element')) {
            $list['allow_booking']             = esc_html__('Booking Element (Forms)','meeeksaas');
        }
        // gallery module/addon
        if (function_exists('meeeksaas_gallery_element')) {
            $list['allow_gallery']             = esc_html__('Photo Gallery Slider','meeeksaas');
        }
        // waitlist module/addon
        if (function_exists('meeeksaas_waitlist_element')) {
            $list['allow_waitlist']             = esc_html__('Waitlist Subscription Forms','meeeksaas');
        }
        // ticket module/addon
        if (function_exists('meeeksaas_ticket_element')) {
            $list['allow_ticket']             = esc_html__('Ticket Element','meeeksaas');
        }

        unset($list['allow_amazon']);
        unset($list['allow_links']);
        unset($list['allow_sell_digital']);
        unset($list['allow_dropdown_btn']);
        unset($list['allow_headers']);
        unset($list['allow_unlimited_links']);

        return $list;
    }
    add_filter( 'meeek_saas_benefits_list', 'meeeksaas_benefits_list_override', 999 );
}

if (!function_exists('meeek_saas_benefits_list')) {
    function meeek_saas_benefits_list_free_accounts(){
        
        $list = array();

        $list['allow_branding']             = esc_html__('Hide Brand Logo','meeeksaas');
        $list['allow_bg']                   = esc_html__('Button Custom Styles','meeeksaas');
        $list['allow_body_bg']              = esc_html__('Page background image','meeeksaas');
        $list['allow_button_label']         = esc_html__('Button Label Bubble','meeeksaas');
        $list['allow_seo_clean_url']        = esc_html__('Custom Links (Clean URL)','meeeksaas');
        $list['allow_seo_clean_title']      = esc_html__('Custom Page Title (No branding)','meeeksaas');
        $list['allow_templates']            = esc_html__('Extended Templates','meeeksaas');
        $list['allow_bio']                  = esc_html__('Custom Profile Picture & Title + Bio Description','meeeksaas');
        $list['allow_seo']                  = esc_html__('SEO Settings','meeeksaas');
        $list['allow_seo_prevent_index']    = esc_html__('Prevent Indexing','meeeksaas');
        
        $list['allow_unlimited_links']      = esc_html__('Unlimited Links','meeeksaas'); //included
        $list['allow_social_icons']         = esc_html__('Social Media Icons','meeeksaas'); //included
        $list['allow_qr']                   = esc_html__('QR Code','meeeksaas'); //included

        // elements
        $list['allow_payment']              = esc_html__('Payments with PayPal & Venmo','meeeksaas');
        $list['allow_header']              = esc_html__('Headers','meeeksaas');
        $list['allow_image']              = esc_html__('Image Element','meeeksaas');
        $list['allow_email']              = esc_html__('Email Me Button','meeeksaas');
        $list['allow_dropdown']             = esc_html__('Dropdown Button Type','meeeksaas');
        $list['allow_youtube']              = esc_html__('YouTube Videos','meeeksaas');
        $list['allow_spotify']              = esc_html__('Spotify Embeds','meeeksaas');
        $list['allow_phone']                = esc_html__('Phone/WhatsApp','meeeksaas');
        $list['allow_twitter']              = esc_html__('Twitter Embed','meeeksaas');
        $list['allow_facebook']             = esc_html__('Facebook Embed','meeeksaas');
        $list['allow_tiktok']               = esc_html__('TikTok Video Embeds','meeeksaas');
        $list['allow_woocommerce'] = esc_html__('WooCommerce Products','meeeksaas');
        $list['allow_blog']        = esc_html__('Blog Articles','meeeksaas');
        $list['allow_vcard']                = esc_html__('vCard QR','meeeksaas'); //included
        $list['allow_g_analytiics']         = esc_html__('Google Analytics','meeeksaas'); //included
        $list['allow_metrics']         = esc_html__('Page Metrics','meeeksaas'); //included
        $list['allow_shortcode']         = esc_html__('WordPress Shortcodes','meeeksaas'); //included
        $list['allow_block']         = esc_html__('WordPress Blocks','meeeksaas'); //included

        // Other (included in all packages)
        $list['allow_support']              = esc_html__('Support','meeeksaas');
        $list['allow_2step_auth']           = esc_html__('2 Step Authentication','meeeksaas');

        return $list;
    }
}


/**
* Package Benefit Descriptions override (from the SaaS module)
* @param $list - array: the benefits list
* @param $benefit_info - string: benefit id (example: allow_branding)
*
*/
if (!function_exists('meeeksaas_benefit_descriptions_override')) {
    function meeeksaas_benefit_descriptions_override($list, $benefit_info) {

        $list = array();
        if (function_exists('meeek_saas_benefits_list')) {
            $list = meeek_saas_benefits_list();

            $list['allow_branding']             = esc_html__('Hide Brand Logo from the footer of your Bio Links Page.','meeeksaas');
            $list['allow_bg']                   = esc_html__('Button Custom Color Pickers for Color/Background.','meeeksaas');
            $list['allow_body_bg']              = esc_html__('Upload a custom image as background.','meeeksaas');
            $list['allow_button_label']         = esc_html__('Button Label with Icon & Text','meeeksaas');
            $list['allow_seo_clean_url']        = esc_html__('Disable the generated ID at the end of your links page','meeeksaas');
            $list['allow_seo_clean_title']      = esc_html__('Set a custom SEO title to your Links Page','meeeksaas');
            $list['allow_templates']            = esc_html__('Access the premium available templates','meeeksaas');
            $list['allow_bio']                  = esc_html__('Custom Profile Picture & Title + Bio Description','meeeksaas');
            $list['allow_seo']                  = esc_html__('SEO Settings','meeeksaas');
            $list['allow_seo_prevent_index']    = esc_html__('Prevent Search Engine Indexing','meeeksaas');
            
            $list['allow_unlimited_links']      = esc_html__('Unlimited Links on your page','meeeksaas'); //included
            $list['allow_social_icons']         = esc_html__('Social Media Icons','meeeksaas'); //included
            $list['allow_qr']                   = esc_html__('QR Code option and sharing','meeeksaas'); //included

            // elements
            $list['allow_payment']              = esc_html__('Accept Payments with PayPal & Venmo','meeeksaas');
            $list['allow_header']               = esc_html__('Group your links with Headers','meeeksaas');
            $list['allow_image']                = esc_html__('Add an image instead of a button','meeeksaas');
            $list['allow_dropdown']             = esc_html__('Dropdows can be populated with text content.','meeeksaas');
            $list['allow_youtube']              = esc_html__('Embed YouTube Videos','meeeksaas');
            $list['allow_spotify']              = esc_html__('Spotify Music Embeds','meeeksaas');
            $list['allow_phone']                = esc_html__('A Phone or WhatsApp dedicated link type','meeeksaas');
            $list['allow_email']                = esc_html__('A Pre-Populated Email Link','meeeksaas');
            $list['allow_twitter']              = esc_html__('Twitter Embed (Tweet, Profile, Lists)','meeeksaas');
            $list['allow_facebook']             = esc_html__('Facebook Embed (Post, Photo, Video)','meeeksaas');
            $list['allow_tiktok']               = esc_html__('TikTok Video Embeds','meeeksaas');

            // Other (included in all packages)
            $list['allow_support']              = esc_html__('Receive Dedicated Customer Support','meeeksaas');
            $list['allow_2step_auth']           = esc_html__('Secured 2 Step Authentication','meeeksaas');
            $list['allow_woocommerce']          = esc_html__('Allow the selection of WooCommerce Products','meeeksaas');
            $list['allow_blog']                 = esc_html__('Allow the selection of Blog Articles','meeeksaas');
            $list['allow_vcard']                = esc_html__('vCard QR(Add me to your contacts)','meeeksaas'); //included
            $list['allow_g_analytiics']         = esc_html__('Google Analytics Tracking Code Field','meeeksaas'); //included
            $list['allow_metrics']              = esc_html__('Page views chart','meeeksaas'); //included
            $list['allow_shortcode']            = esc_html__('WordPress Shortcodes inside our outside an accordion','meeeksaas'); //included
            $list['allow_block']                = esc_html__('WordPress Blocks inside our outside an accordion','meeeksaas'); //included

            // newsletter module/addon
            if (function_exists('meeeksaas_newsletter_element')) {
                $list['allow_newsletter']             = esc_html__('Newsletter Subscription Forms', 'meeeksaas');
            }
            // booking module/addon
            if (function_exists('meeeksaas_booking_element')) {
                $list['allow_booking']             = esc_html__('Booking Element (Forms)', 'meeeksaas');
            }
            // gallery module/addon
            if (function_exists('meeeksaas_gallery_element')) {
                $list['allow_gallery']             = esc_html__('Photo Gallery Slider', 'meeeksaas');
            }
            // waitlist module/addon
            if (function_exists('meeeksaas_waitlist_element')) {
                $list['allow_waitlist']             = esc_html__('Waitlist Subscription Forms', 'meeeksaas');
            }
            // ticket module/addon
            if (function_exists('meeeksaas_ticket_element')) {
                $list['allow_ticket']             = esc_html__('Ticket Element','meeeksaas');
            }
        }
        
        return $list[$benefit_info];

    }
    add_filter( 'meeek_saas_benefit_description', 'meeeksaas_benefit_descriptions_override', 10, 2);
}
