<?php
if ( ! defined( 'ABSPATH' ) ) {
	exit;
}
global $current_user;
wp_get_current_user();

// Check if $_GET isset
if (isset($_GET['links_page'])) {
	// disable the post.
	// this sends the post to trash.
	echo meeeksaas_delete_links_page($_GET['links_page'], MEEEKSAAS_DEV_MODE);
}

$builder_url = wc_get_endpoint_url('bio-link-builder', '', wc_get_page_permalink( 'myaccount' ));
$links_pages_url = wc_get_endpoint_url('my-link-pages', '', wc_get_page_permalink( 'myaccount' ));

$plans_url = '';
if (function_exists('wc_get_endpoint_url')) {
    $plans_url = wc_get_endpoint_url('pricing-plan', '', wc_get_page_permalink( 'myaccount' ));
}


?>
<div class="my-3 p-3 bg-body rounded shadow-sm">
    <h3 class="border-bottom pb-2 mb-0">
    	<?php echo esc_html__('Bio Links Pages','meeeksaas'); ?>
		<a href="<?php echo esc_url($builder_url); ?>" class="btn btn-outline-primary btn-meeeksaas-border btn-sm"><?php echo esc_html__('New Page','meeeksaas') ?></a>
	</h3>

	<?php 
	$listings_query_arg = array(
		'post_type' => 'meeek-link', 
		'author' => $current_user->ID,
		'posts_per_page' => -1,
		'post_status' => array(
			'publish', 
			'draft', 
			'pending'
		)
	);
	$listings_query = new WP_Query( $listings_query_arg );

	if( $listings_query->have_posts() ) { ?>
		<?php 
		while ( $listings_query->have_posts() ) : $listings_query->the_post(); 
		?>			
		<div id="links-page-<?php the_ID(); ?>" class="meeek-single-link-page">
			<div class="d-flex  text-body-secondary pt-3">
				<div class="pb-3 mb-0 small lh-sm border-bottom w-100">
					<div class="d-flex flex-nowrap justify-content-between">
		        		<h4 class="listing-name">
				        	<a target="_blank" href="<?php echo get_permalink(get_the_ID()); ?>"><?php the_title(); ?></a>
			        		<span class="status-listing status-<?php echo esc_attr(get_post_status(get_the_ID())); ?>">
			        			<?php 
				        			if(get_post_status(get_the_ID()) == 'publish' ) {
				        				echo '<span class="badge bg-success">'.esc_html__('Published', 'meeeksaas').'</span>';
				        			} elseif(get_post_status(get_the_ID()) == 'draft' || get_post_status(get_the_ID()) == 'pending' ) {
				        				echo '<span class="badge bg-warning text-dark">'.esc_html__('Draft', 'meeeksaas').'</span>';
				        			}
			        			?>
			        		</span>
				        </h4>

				        <div>
				        	<?php $edit_link = $builder_url.'?links_page='.get_the_ID().'&tab=analytics'; ?>
				        	<?php echo meeeksaas_get_alltime_pageviews(get_the_ID()).' <a href="'.esc_url($edit_link).'"><span class="dashicons dashicons-chart-area"></span></a>'; ?>
				        </div>
		        		<?php if(meeeksaas_user_has_active_plans() || meeeksaas_free_accounts_enabled()){ ?>
							<div class="btn-group float-end">
								<a target="_blank" href="<?php echo get_permalink(get_the_ID()); ?>" class="btn btn-outline-primary"><i class="far fa-eye"></i></a>
								<a href="<?php echo esc_url($builder_url); ?>?links_page=<?php the_ID(); ?>" class="btn btn-outline-primary"><i class="far fa-edit"></i></a>
								<a href="<?php echo esc_url($links_pages_url).'?delete=yes&links_page='.esc_attr(get_the_ID()); ?>" class="btn btn-outline-primary"><i class="fas fa-trash-alt"></i></a>
							</div>
		        		<?php }else{ ?>
							<div class="btn-group float-end">
								<a data-bs-toggle="tooltip" data-bs-placement="top" data-bs-title="<?php esc_attr_e('Your plan has expired. To edit your bio links pages, please renew the subscription.', 'meeeksaas'); ?>"  href="<?php echo esc_url($plans_url.'/#purchase'); ?>" class="btn btn-outline-primary btn-meeeksaas-border"><i class="fas fa-file-invoice-dollar"></i> <?php esc_html_e('Renew Subscription', 'meeeksaas'); ?></a>
								<a href="<?php echo esc_url($links_pages_url).'?delete=yes&links_page='.esc_attr(get_the_ID()); ?>" class="btn btn-outline-primary"><i class="fas fa-trash-alt"></i></a>
							</div>
		        		<?php } ?>
					</div>
				</div>
			</div>
		</div>


		<?php endwhile;
		wp_reset_postdata();
		?>
	<?php }else{ ?>
        <?php do_action('meeeksaas_no_active_plans_notice', 'pages'); ?>
	<?php } ?>
</div>