<?php
if ( ! defined( 'ABSPATH' ) ) {
    exit; // Exit if accessed directly.
}

function meeeksaas_builder_endpoint() {
    add_rewrite_endpoint( 'bio-link-builder', EP_ROOT | EP_PAGES );
    add_rewrite_endpoint( 'my-link-pages', EP_ROOT | EP_PAGES );
}
add_action( 'init', 'meeeksaas_builder_endpoint' );
  
// ------------------
// 2. Add new query var
function meeeksaas_builder_query_vars( $vars ) {
    $vars[] = 'bio-link-builder';
    $vars[] = 'my-link-pages';
    return $vars;
}
add_filter( 'query_vars', 'meeeksaas_builder_query_vars', 0 );
  
// ------------------
// 3. Insert the new endpoint into the My Account menu
function meeeksaas_builder_link_my_account( $items ) {

    unset($items['customer-logout']);
    $items['my-link-pages'] = esc_html__('Bio Links', 'meeeksaas');
    $items['customer-logout'] = esc_html__('Logout', 'meeeksaas');
    
    return $items;
}
add_filter( 'woocommerce_account_menu_items', 'meeeksaas_builder_link_my_account' );
  
// ------------------
// 4. Add content to the new tab
function meeeksaas_builder_content() { ?>
    <div class="meeeksaas-builder-wrapper">
        <?php 
        $links_page_id = '';
        if (isset($_GET['links_page'])) {
            $links_page_id = $_GET['links_page'];
            echo '<h3>'.esc_html__('Editing ', 'meeeksaas').get_the_title($links_page_id).'</h3>';
        }
        // Builder Hook
        do_action('meeeksaas_page_builder_frontend', $links_page_id); ?>
    </div>
    <?php 
}
  
add_action( 'woocommerce_account_bio-link-builder_endpoint', 'meeeksaas_builder_content' );

// ------------------
// 4. Add content to the new tab
function meeeksaas_my_link_pages_content() {
   require_once('my-links-pages.php');
}
  
add_action( 'woocommerce_account_my-link-pages_endpoint', 'meeeksaas_my_link_pages_content' );



//Disable active listing post
function meeeksaas_delete_links_page($post_id, $devmode){

    $html = '';

    if (isset($_GET['delete']) && isset($_GET['links_page']) && $_GET['delete'] == 'yes') {
        $post_id = $_GET['links_page'];
        $postUserId = get_post_field( 'post_author', $post_id );
        $loggedInUser = get_current_user_id();

        // Prevent other users from deleting other listings
        // Only Listing Author can remove it (from frontend)
        // Security check #1
        if ($postUserId == $loggedInUser) {
            //Prevent users to remove other post or pages than meeek-links
            //Security check #2
            if (get_post_type( $post_id ) == 'meeek-link' || get_post_type( $post_id ) == 'mt_reviews' ) {
                if ($devmode == true) {
                    $html .= '<div class="alert alert-warning alert-dismissible">
                                <a href="#" class="close" data-dismiss="alert" aria-label="close">&times;</a>
                                <strong>'.esc_html__('Developer Mode Enabled. ', 'meeeksaas').'</strong> '.esc_html__('Selected page will not be disabled. In order to enable it, please set the Developer Mode Status to Off', 'meeeksaas').'
                              </div>';
                }else{
                    wp_trash_post($post_id);
                    $html .= '<div class="alert alert-success alert-dismissible">
                                <a href="#" class="close" data-dismiss="alert" aria-label="close">&times;</a>
                                <strong>'.esc_html__('Success!', 'meeeksaas').'</strong> '.esc_html__('Selected page is now Disabled.', 'meeeksaas').'
                              </div>';
                }
            }else{
                $html .= '<div class="alert alert-danger alert-dismissible">
                            <a href="#" class="close" data-dismiss="alert" aria-label="close">&times;</a>
                            <strong>'.esc_html__('Error!', 'meeeksaas').'</strong> '.esc_html__('You are not allowed to do this action.', 'meeeksaas').'
                          </div>';
            }
        }else{
            $html .= '<div class="alert alert-danger alert-dismissible">
                        <a href="#" class="close" data-dismiss="alert" aria-label="close">&times;</a>
                        <strong>'.esc_html__('Error!', 'meeeksaas').'</strong> '.esc_html__('You are not allowed to do this action.', 'meeeksaas').'
                      </div>';
        }
    }

    return $html;
}