<?php
/**
 * Add the new element on the Elements importable modal
 * 
 */
function meeeksaas_gallery_element(){ ?>
  <div class="list-inline col-md-6 mb-4">
    <div class="relative">
      <div class="list-inline-item align-middle">
        <div class="feature-icon bg-gallery">
          <i class="far fa-images"></i>
        </div>
      </div>
      <div class="list-inline-item align-middle">
        <h5 class="mb-0"><?php esc_html_e('Photo Gallery', 'meeeksaas'); ?></h5>
        <p class="m-0"><?php esc_html_e('A Photo Gallery', 'meeeksaas'); ?></p>
      </div>
      <div class="list-inline-item align-middle float-end mt-2">
        <?php do_action('meeeksaas_element_add_button', 'gallery'); ?>
      </div>
      <?php do_action('meeeksaas_builder_allow_gallery'); ?>
    </div>
  </div><?php
}
add_action('meeeksaas_after_elements_list', 'meeeksaas_gallery_element');


/**
 * Map the new element on the import accepted elements array
 * 
 * @param $all_elements: array containing all the default elements
 */
function meeeksaas_add_gallery_el_to_els($all_elements){
  array_push($all_elements, 'gallery');
  
  return $all_elements;
}
add_filter('meeeksaas_available_elements', 'meeeksaas_add_gallery_el_to_els');

/**
 * Map the new element on the import accepted elements array
 * 
 * @param $all_elements: array containing all the default elements
 */
function meeeksaas_add_gallery_builder_fields($meeek_configuration){
  
    $title = ((array_key_exists('title', $meeek_configuration))?$meeek_configuration['title']:esc_html__('Button Text', 'meeeksaas'));
    $radius = ((array_key_exists('gallery_radius', $meeek_configuration))?$meeek_configuration['gallery_radius']:'rounded');
    $title_color = ((array_key_exists('title_color', $meeek_configuration))?$meeek_configuration['title_color']:'#000000');
    $title_alignment = ((array_key_exists('title_alignment', $meeek_configuration))?$meeek_configuration['title_alignment']:'center');
  
    echo meeeksaas_input('text', 'title', $title, esc_html__('Button Text', 'meeeksaas'), 'meeeksaas_title', true);
    echo meeeksaas_media_gallery_uploader('media_ids', $meeek_configuration, esc_html__('Gallery Photos', 'meeeksaas'), 'allow_bg');
    echo meeeksaas_radius_group('gallery_radius', $radius, esc_html__('Photo Radius', 'meeeksaas'));
    echo meeeksaas_colorpicker('title_color', $title_color, esc_html__('Title Color', 'meeeksaas'), 'title_color');
    echo meeeksaas_alignment_group('title_alignment', $title_alignment, esc_html__('Title Alignment', 'meeeksaas'));

}
add_action('meeeksaas_gallery_builder_fields', 'meeeksaas_add_gallery_builder_fields');




// YouTube Embed
function meeeksaas_gallery_frontend($type = '', $item = array() ){
  if($type == 'gallery'){ ?><?php

    $title = ((array_key_exists('title', $item['vcard']))?$item['vcard']['title']:'');
    $radius = ((array_key_exists('gallery_radius', $item['vcard']))?$item['vcard']['gallery_radius']:'rounded');
    $title_color = ((array_key_exists('title_color', $item['vcard']))?$item['vcard']['title_color']:'#000000');
    $title_alignment = ((array_key_exists('title_alignment', $item['vcard']))?$item['vcard']['title_alignment']:'center');

    $media = array();
    foreach ($item['vcard'] as $key => $value) {
      if (preg_match('/gallery_media_id_(\d+)/', $key, $matches)) {
          $id = $matches[1];
          $media[$id]['id'] = $value;
      } elseif (preg_match('/gallery_media_url_(\d+)/', $key, $matches)) {
          $id = $matches[1];
          $media[$id]['url'] = $value;
      } elseif (preg_match('/gallery_media_title_(\d+)/', $key, $matches)) {
          $id = $matches[1];
          $media[$id]['title'] = $value;
      }
    }  ?>

  <div class="meeeksaas-gallery-element">
    <h3 class="text-<?php echo esc_attr($title_alignment); ?>" style="color:<?php echo esc_attr($title_color); ?>;"><?php echo esc_html($title); ?></h3>
    <div class="owl-carousel owl-theme meeeksaas-gallery-slider"><?php 
      foreach ($media as $id => $data) {
          $img_title = ((array_key_exists('title', $data))?$data['title']:'');
          if (isset($data['id']) && isset($data['url'])) { ?>
            <div class="item">
                <a href="<?php echo esc_url($data['url']); ?>">
                  <?php if($img_title){ ?><div class="gallery-item-title"><?php echo esc_html($img_title); ?></div><?php } ?>
                  <img alt="image" class="<?php echo esc_attr($radius); ?>" src="<?php echo esc_url(wp_get_attachment_image_url($data['id'], 'large')); ?>">
                </a>
            </div><?php 
          }
      } ?>
    </div>
  </div>
  <script type="text/javascript">
    jQuery(document).ready(function () {
      jQuery('.meeeksaas-gallery-slider').owlCarousel({
        loop:true,
        mouseDrag:true,
        touchDrag:true,
        margin:15,
        responsiveClass:true,
        dots:true,
        autoHeight:true,
        responsive:{
          0:{
              items:1,
              nav:true
          },
          600:{
              items:1,
              nav:true
          },
          1000:{
              items:1,
              nav:true,
          }
        }
      });
    });
  </script>
  <?php 

  }
}
add_action('meeeksaas_bio_gallery_bottom', 'meeeksaas_gallery_frontend', 10, 2);



/** 
 * Fieldtype: Media Uploader
 * 
 * @param name: radio name attribute
 * @param value: radio checked value
 * @param label: label text
*/
function meeeksaas_media_gallery_uploader($name = '', $meeek_configuration = array(), $label = '', $benefit = ''){

    $photo_image = '';
    $this_benefit = $benefit;
    ?>
    <div class="meeek-image-uploader-box meeek-image-multi-uploader-box mb-3 relative">
        <label><?php echo esc_html($label); ?></label>
        <div class="clearfix"></div>
        <div class="meeeksaas_image_preview_box_gallery_imgs"><?php echo meeeksaas_media_gallery_fields($meeek_configuration); ?></div>
        <!-- upload btn -->
        <div class="meeeksaas_image_preview_box_gallery upload-now"></div>
        <?php do_action('meeeksaas_builder_'.$benefit); ?>
    </div>
    <?php 
}


function meeeksaas_media_gallery_fields($element){
  $media = [];
  foreach ($element as $key => $value) {
      if (preg_match('/gallery_media_id_(\d+)/', $key, $matches)) {
          $id = $matches[1];
          $media[$id]['id'] = $value;
      } elseif (preg_match('/gallery_media_url_(\d+)/', $key, $matches)) {
          $id = $matches[1];
          $media[$id]['url'] = $value;
      } elseif (preg_match('/gallery_media_title_(\d+)/', $key, $matches)) {
          $id = $matches[1];
          $media[$id]['title'] = $value;
      }
  } 
  ?>

  <div class="meeeksaas_media_gallery_fields"><?php 
    foreach ($media as $id => $data) {
        if (isset($data['id']) && isset($data['url'])) { 
          $url = ((array_key_exists('url', $data))?$data['url']:'#');
          $title = ((array_key_exists('title', $data))?$data['title']:'');
          ?>
          <input type="hidden" name="meeek-bio-links-group[2][gallery_media_id_<?php echo esc_attr($data['id']); ?>]" value="<?php echo esc_attr($data['id']); ?>" class="custom-link" data-id="<?php echo esc_attr($data['id']); ?>">
          <div class="row mb-2">
            <div class="col-md-2 col-xs-12">
              <img src="<?php echo esc_url(wp_get_attachment_image_url($data['id'], 'thumbnail')); ?>" style="max-width: 70px;">
            </div>
            <div class="col-md-5 col-xs-12">
              <?php esc_html_e('Image link:', 'meeeksaas'); ?>
              <input type="text" style="width: 100%;" name="meeek-bio-links-group[2][gallery_media_url_<?php echo esc_attr($data['id']); ?>]" value="<?php echo esc_url($url); ?>" placeholder="<?php esc_attr_e('Link', 'meeeksaas'); ?>" class="custom-link" data-id="<?php echo esc_attr($data['id']); ?>">
            </div>
            <div class="col-md-5 col-xs-12">
              <?php esc_html_e('Image Title:', 'meeeksaas'); ?>
              <input type="text" style="width: 100%;" name="meeek-bio-links-group[2][gallery_media_title_<?php echo esc_attr($data['id']); ?>]" value="<?php echo esc_attr($title); ?>" placeholder="<?php esc_attr_e('Title', 'meeeksaas'); ?>" class="custom-title" data-id="<?php echo esc_attr($data['id']); ?>">
            </div>
          </div><?php 
        }
    } ?>
  </div><?php 
}