<?php

/**
 * Add the new element on the Elements importable modal
 * 
 */
function meeeksaas_newsletter_element(){ ?>
  <div class="list-inline col-md-6 mb-4">
    <div class="relative">
      <div class="list-inline-item align-middle">
        <div class="feature-icon bg-newsletter">
          <i class="far fa-envelope-open"></i>
        </div>
      </div>
      <div class="list-inline-item align-middle">
        <h5 class="mb-0"><?php esc_html_e('Email Subscribe form', 'meeeksaas'); ?></h5>
        <p class="m-0"><?php esc_html_e('A Subscription Form', 'meeeksaas'); ?></p>
      </div>
      <div class="list-inline-item align-middle float-end mt-2">
        <?php do_action('meeeksaas_element_add_button', 'newsletter'); ?>
      </div>
      <?php do_action('meeeksaas_builder_allow_newsletter'); ?>
    </div>
  </div><?php
}
add_action('meeeksaas_after_elements_list', 'meeeksaas_newsletter_element');

/**
 * Map the new element on the import accepted elements array
 * 
 * @param $all_elements: array containing all the default elements
 */
function meeeksaas_add_newsletter_el_to_els($all_elements){
  array_push($all_elements, 'newsletter');
  
  return $all_elements;
}
add_filter('meeeksaas_available_elements', 'meeeksaas_add_newsletter_el_to_els');

/**
 * Map the new element on the import accepted elements array
 * 
 * @param $all_elements: array containing all the default elements
 */
function meeeksaas_add_newsletter_builder_fields($meeek_configuration){

    $title = ((array_key_exists('title', $meeek_configuration))?$meeek_configuration['title']:esc_html__('Button Text', 'meeeksaas'));
    $subtitle = ((array_key_exists('subtitle', $meeek_configuration))?$meeek_configuration['subtitle']:esc_html__('Subtitle', 'meeeksaas'));
    $email_to = ((array_key_exists('email_to', $meeek_configuration))?$meeek_configuration['email_to']:esc_html__('Email Address', 'meeeksaas'));
    $toggle_status = ((array_key_exists('toggle_status', $meeek_configuration))?$meeek_configuration['toggle_status'][0]:'off');
    $style_version = ((array_key_exists('style_version', $meeek_configuration))?$meeek_configuration['style_version'][0]:'off');
    $header_form = ((array_key_exists('header_form', $meeek_configuration))?$meeek_configuration['header_form'][0]:'off');
    $footer_form = ((array_key_exists('footer_form', $meeek_configuration))?$meeek_configuration['footer_form'][0]:'off');
  
    echo meeeksaas_input('text', 'title', $title, esc_html__('Button Text', 'meeeksaas'), 'meeeksaas_title', true);
    echo meeeksaas_input('text', 'subtitle', $subtitle, esc_html__('Subtitle', 'meeeksaas'), 'meeeksaas_subtitle', true);
    echo meeeksaas_input('text', 'email_to', $email_to, esc_html__('Email Address', 'meeeksaas'), 'email_to', true);
    echo meeeksaas_checkbox('toggle_status', 'toggle_status', esc_html__('Inline Form (No Link)', 'meeeksaas'), $toggle_status);
    echo meeeksaas_checkbox('style_version', 'style_version', esc_html__('Dark Style (If unchecked, the default style will be White background and black text).', 'meeeksaas'), $style_version);
    echo meeeksaas_checkbox('header_form', 'header_form', esc_html__('Header Subscribe Button', 'meeeksaas'), $header_form);
    echo meeeksaas_checkbox('footer_form', 'footer_form', esc_html__('Sticky Bottom Subscribe Bar', 'meeeksaas'), $footer_form);
}
add_action('meeeksaas_newsletter_builder_fields', 'meeeksaas_add_newsletter_builder_fields');



// Function to create the table
function meeeksaas_create_subscriptions_table() {
    global $wpdb;
    $table_name = $wpdb->prefix . 'meeeksaas_subscriptions'; // Create the table name with WP prefix
    $charset_collate = $wpdb->get_charset_collate();

    // SQL statement to create the table
    $sql = "CREATE TABLE $table_name (
        ID int(11) NOT NULL AUTO_INCREMENT,
        fullname varchar(200) NOT NULL,
        email varchar(200) NOT NULL,
        favorite_topic varchar(200) NOT NULL,
        user_id int(10) NOT NULL,
        double_opt_in int(10) NOT NULL,
        date datetime DEFAULT CURRENT_TIMESTAMP NOT NULL,
        PRIMARY KEY  (ID)
    ) $charset_collate;";

    // Include the upgrade file and run the dbDelta function
    require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
    dbDelta($sql);
}

// Hook the table creation function to the after_setup_theme action
add_action('after_setup_theme', 'meeeksaas_create_subscriptions_table');




if (!function_exists('meeeksaas_subscribe_element_database_save_subscription')) {
  function meeeksaas_subscribe_element_database_save_subscription($form_fields) {

    $name = $form_fields['fullname'];
    $email = $form_fields['email'];
    $favorite_topic = $form_fields['favorite_topic'];
    $list_owner = $form_fields['list_owner'];

    global $wpdb;
    
    $table_name = $wpdb->prefix . 'meeeksaas_subscriptions';
    $user_id = $list_owner;

    // Check if a row exists for the given email and user_id
    $existing_row = $wpdb->get_row($wpdb->prepare(
        "SELECT * FROM $table_name WHERE email = %s AND user_id = %d",
        $email, $user_id
    ));

    if ($existing_row) {
        // Update the existing row
        $wpdb->update(
            $table_name,
            array(
                'double_opt_in' => 1, // Assuming we want to update double_opt_in field
                'date' => current_time('mysql') // Update the date to current time
            ),
            array('ID' => $existing_row->ID)
        );
    } else {
        // Insert a new row
        $wpdb->insert(
            $table_name,
            array(
                'fullname' => esc_html($name),
                'email' => esc_html($email),
                'favorite_topic' => esc_html($favorite_topic),
                'user_id' => esc_html($user_id),
                'double_opt_in' => 0, // Assuming default value for new records
            )
        );
    }
  }
}

function meeeksaas_subscription_exists($email, $user_id) {
    global $wpdb;
    
    $table_name = $wpdb->prefix . 'meeeksaas_subscriptions';

    // Check if a row exists for the given email and user_id
    $existing_row = $wpdb->get_var($wpdb->prepare(
        "SELECT COUNT(*) FROM $table_name WHERE email = %s AND user_id = %d",
        $email, $user_id
    ));

    if($existing_row == '1'){
      return true;
    }else{
      return false;
    }
}


/**
* Edit as Admin link
*
*/
function meeeksaas_newsletter_header_button_frontend(){ 
  $meeek_configuration = get_post_meta( get_the_ID(), 'meeek_configuration', true );
  if(meeeksaas_has_newsletter_header_btn_type($meeek_configuration, 'header')){ ?>
    <a target="_blank" data-bs-toggle="modal" data-bs-target="#meeeksaas_subscribe_modal"  class="meeeksaas-top-subscribe-btn" href="#"><i class="fas fa-bell fa-shake"></i> <?php esc_html_e('Subscribe', 'meeeksaas'); ?></a><?php 
  }
}
add_action('meeeksaas_before_bio_links_group', 'meeeksaas_newsletter_header_button_frontend');


function meeeksaas_newsletter_footer_fixed_button_frontend(){ 
  $meeek_configuration = get_post_meta( get_the_ID(), 'meeek_configuration', true );
  if(meeeksaas_has_newsletter_header_btn_type($meeek_configuration, 'footer')){ ?>
    <div class="meeeksaas-subscribe-fixed-bar alert alert-dismissible fade show" role="alert">
      <p><a target="_blank" data-bs-toggle="modal" data-bs-target="#meeeksaas_subscribe_modal"  class="meeeksaas-fixed-subscribe-btn" href="#"><i class="fas fa-bell fa-shake"></i> <?php esc_html_e('Subscribe', 'meeeksaas'); ?></a> <?php esc_html_e('to be the first to know about new content', 'meeeksaas'); ?></p>
      <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="<?php esc_attr_e('Close', 'meeeksaas'); ?>"></button>
    </div><?php 
  }
}
add_action('meeeksaas_page_footer', 'meeeksaas_newsletter_footer_fixed_button_frontend');


function meeeksaas_has_newsletter_header_btn_type($meeek_configuration, $position = '') {
    // Check if 'meeek-bio-links-group' key exists and is an array
    if (isset($meeek_configuration['meeek-bio-links-group']) && is_array($meeek_configuration['meeek-bio-links-group'])) {
        // Loop through the 'meeek-bio-links-group' array
        foreach ($meeek_configuration['meeek-bio-links-group'] as $item) {
            // Check if 'btn_type' key exists and if its value is 'newsletter'
            if (isset($item['btn_type']) && $item['btn_type'] === 'newsletter') {
              if ($position == 'header') {
                $status = ((array_key_exists('header_form', $item))?$item['header_form'][0]:"off");
              }else{
                $status = ((array_key_exists('footer_form', $item))?$item['footer_form'][0]:"off");
              }
              if ($status == 'on') {
                return true;
              }
            }
        }
    }
    return false;
}



function meeeksaas_newsletter_form_frontend(){ 
  $author_id = get_post_field('post_author', get_the_ID());

  if (isset($_GET['action']) && $_GET['action'] === 'newsletter-step-1' && isset($_GET['email'])) { 
    ?>
    <div class="alert alert-warning alert-dismissible fade show" role="alert">
      <?php 
      if (meeeksaas_subscription_exists($_GET['email'], $author_id)) {
        esc_html_e('You are already subscribed for this author. If your subscription is not yet confirm, please check your inbox and confirm.', 'meeeksaas');
      }else{
        esc_html_e('Thank you for signing up for our newsletter. To confirm your subscription please check your email.', 'meeeksaas');
      }
      ?>
      <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="<?php esc_attr_e('Close', 'meeeksaas'); ?>"></button>
    </div>
    <?php
  }elseif (isset($_GET['action']) && $_GET['action'] === 'newsletter-confirmation' && isset($_GET['email'])) {
    ?>
    <div class="alert alert-success alert-dismissible fade show" role="alert">
      <?php 
        esc_html_e('Your newsletter subscription is now confirmed! Thank you!', 'meeeksaas');
      ?>
      <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="<?php esc_attr_e('Close', 'meeeksaas'); ?>"></button>
    </div>
    <?php
  }else{
    // ....
  }
}
add_action('meeeksaas_before_bio_links_group', 'meeeksaas_newsletter_form_frontend');



function meeeksaas_newsletter_shortcode_form($params, $content) {
    extract( shortcode_atts( 
      array(
        'author_id'            => '',
        'title'            => '',
        'subtitle'            => '',
        'style_mode'            => '',
      ), $params ) );

    $terms_id = 'terms_'.uniqid();
    $contact_id = 'contact_'.uniqid();

    $title_text = esc_html__('Join My Waiting List', 'meeeksaas');
    if (!empty($title)) {
      $title_text = $title;
    }
    $subtitle_text = esc_html__('Sign up here to get the latest updates.', 'meeeksaas');
    if (!empty($subtitle)) {
      $subtitle_text = $subtitle;
    }

    ob_start(); ?>

    <form method="GET" action="<?php the_permalink(); ?>" class="meeeksaas-subscribe-form <?php echo esc_attr($style_mode); ?>">
 
      <h3 class="text-center"><?php echo esc_html($title_text); ?></h3>
      <p class="text-center"><?php echo esc_html($subtitle_text); ?></p>

      <input name="list_owner_page_id" type="hidden"  value="<?php echo esc_attr(get_the_ID()); ?>" placeholder="<?php esc_attr_e('page id', 'meeeksaas'); ?>" />
      <input name="list_owner" type="hidden"  value="<?php echo esc_attr($author_id); ?>" placeholder="<?php esc_attr_e('list owner', 'meeeksaas'); ?>" />
      <input name="action" type="hidden"  value="newsletter-step-1"  placeholder="<?php esc_attr_e('user id', 'meeeksaas'); ?>" />
      <input name="fullname" required type="text" value="" placeholder="<?php esc_attr_e('Name *', 'meeeksaas'); ?>" class="mb-2" />
      <input name="email" required type="email" value="" placeholder="<?php esc_attr_e('Email *', 'meeeksaas'); ?>" class="mb-2" />
      <input name="favorite_topic" required type="text" value="" placeholder="<?php esc_attr_e('Favorite Topic *', 'meeeksaas'); ?>" class="mb-3" />

      <p><input type="checkbox"  name="contact_consent" value="contact" id="<?php echo esc_attr($contact_id); ?>" required /> <label for="<?php echo esc_attr($contact_id); ?>"><?php esc_html_e('I agree to my contact details being shared with', 'meeeksaas'); ?> <?php the_title(); ?><?php esc_html_e(', who may contact me. *', 'meeeksaas'); ?></label></p>

      <input type="submit" value="<?php esc_attr_e('Subscribe now', 'meeeksaas'); ?>">
    </form>

    <?php
    return ob_get_clean();
}
add_shortcode('meeeksaas-newsletter-form', 'meeeksaas_newsletter_shortcode_form');


function meeeksaas_subscribe_element_check_for_url_parameter() {
    // email submit
    if (isset($_GET['action']) && $_GET['action'] === 'newsletter-step-1' && isset($_GET['email'])) {
        $email = sanitize_email($_GET['email']);
        $list_owner = esc_attr($_GET['list_owner']);
        $page_id = esc_attr($_GET['list_owner_page_id']);
        if (!meeeksaas_subscription_exists($_GET['email'], $list_owner)) {
          meeeksaas_subscribe_element_send_newsletter_email($_GET);
          meeeksaas_subscribe_element_database_save_subscription($_GET);
        }
    }

    // databse save
    if (isset($_GET['action']) && $_GET['action'] === 'newsletter-confirmation' && isset($_GET['email'])) {
      $email = sanitize_email($_GET['email']);
      $list_owner = esc_attr($_GET['list_owner']);
      meeeksaas_subscribe_element_database_save_subscription($_GET);
    }
}
add_action('template_redirect', 'meeeksaas_subscribe_element_check_for_url_parameter');


function meeeksaas_subscribe_element_send_newsletter_email($form_fields) {
    $email = sanitize_email($form_fields['email']);
    $subject = get_bloginfo().esc_html__(': Subscription Confirmation', 'meeeksaas');
    $message = meeeksaas_subscribe_element_get_newsletter_email_content($form_fields);
    $headers = array('Content-Type: text/html; charset=UTF-8');
    $to = $email;
    wp_mail($to, $subject, $message, $headers);
}

function meeeksaas_subscribe_element_get_newsletter_email_content($form_fields) {
    ob_start();

    $email = $form_fields['email'];
    $list_owner = $form_fields['list_owner'];
    $page_id = $form_fields['list_owner_page_id'];
    $fullname = $form_fields['fullname'];
    $favorite_topic = $form_fields['favorite_topic'];

    $confirm_url = add_query_arg( array(
      'list_owner' => esc_attr($list_owner),
      'action' => 'newsletter-confirmation',
      'email' => esc_attr($email),
      'fullname' => esc_attr($fullname),
      'favorite_topic' => esc_attr($favorite_topic),
    ), get_the_permalink($page_id) );

    $body_style = 'font-family: Arial, sans-serif;';
    $btn_style = 'border: none; border-radius: 3px; color: rgb(255, 255, 255); padding: 10px 25px;text-decoration: none; background: rgb(0, 166, 249); color: rgb(255, 255, 255); font-family: Arial, sans-serif; font-size: 16px; font-weight: normal; line-height: 120%; text-transform: none; margin: 0px;'; ?>

    <html>
    <body style="<?php echo esc_attr($body_style); ?>">
      <h1><?php esc_html_e('Please confirm your subscription!', 'meeeksaas'); ?></h1>
      <p><?php esc_html_e('Thank you for signing up for our newsletter. To confirm your subscription to', 'meeeksaas'); ?> <a href="<?php echo get_the_permalink($page_id); ?>" target="_blank"><?php echo get_the_title($page_id); ?></a><?php esc_html_e(', please click on the button below:', 'meeeksaas'); ?></p>
      <a href="<?php echo esc_url($confirm_url); ?>" target="_blank" style="<?php echo esc_attr($btn_style); ?>"><b><?php esc_html_e('Confirm Subscription', 'meeeksaas'); ?></b></a>
      <p><?php esc_html_e('If you received this email by mistake or dont wish to subscribe anymore, simply ignore this message.', 'meeeksaas'); ?></p>
    </body>
    </html>

    <?php
    return ob_get_clean();
}


// Newsletter frontend elements
function meeeksaas_newsletter_frontend($item = '', $version = ''){
  $type = ((array_key_exists('btn_type', $item))?$item['btn_type']:"newsletter");
  if($type == 'newsletter'){
    $style_version = ((array_key_exists('style_version', $item))?$item['style_version'][0]:"off");
    $toggle_status = ((array_key_exists('toggle_status', $item))?$item['toggle_status'][0]:"off");
    $title = ((array_key_exists('title', $item))?$item['title']:"");
    $subtitle = ((array_key_exists('subtitle', $item))?$item['subtitle']:"");
    $style = 'meeeksaas-newsletter-light-texts';
    if ($style_version == 'off') {
      $style = 'meeeksaas-newsletter-dark-texts';
    }

    $author_id = get_post_field('post_author', get_the_ID()); ?>
    <?php if($toggle_status == 'off'){ ?>

      <div class="modal fade text-center meeeksaas-modal-subscribe" id="meeeksaas_subscribe_modal" tabindex="-1" aria-labelledby="meeeksaas_subscribe_modalLabel" aria-hidden="true">
        <div class="modal-dialog modal-dialog-centered modal-dialog-scrollable">
          <div class="modal-content">
            <div class="modal-header p-4">
              <h5 class="modal-title"><?php echo esc_html__('Subscribe to ', 'meeeksaas').get_the_title(); ?></h5>
              <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="<?php esc_attr_e('Close', 'meeeksaas'); ?>"></button>
            </div>
            <div class="modal-body p-4">
              <?php echo do_shortcode('[meeeksaas-newsletter-form author_id="'.esc_attr($author_id).'" style_mode="meeeksaas-newsletter-dark-texts" title="'.esc_attr($title).'" subtitle="'.esc_attr($subtitle).'"]'); ?>
            </div>
          </div>
        </div>
      </div>

      <div class="meeeksaas-single-link-holder meeeksaas-single-link--<?php echo esc_attr($version); ?> meeeksaas-el--newsletter">
        <div class="meeeksaas-el-inner--newsletter">
          <i class="fas fa-bell fa-shake"></i> <?php echo esc_html($title); ?>
          <a aria-label="<?php echo esc_attr($title); ?>" target="_blank" data-bs-toggle="modal" data-bs-target="#meeeksaas_subscribe_modal" class="meeeksaas-subscribe-link-btn" href="#"></a>
        </div>
      </div>
    <?php }else{ 
        echo do_shortcode('[meeeksaas-newsletter-form author_id="'.esc_attr($author_id).'" style_mode="'.esc_attr($style).'" title="'.esc_attr($title).'" subtitle="'.esc_attr($subtitle).'"]');
    } 
  }
}
add_action('meeeksaas_bio_link_element', 'meeeksaas_newsletter_frontend', 10, 2);


/**
* WooCommerce accounts: My Dashboard quicklinks
*/
function meeeksaas_my_subscription_list_Account() {

  $current_user = wp_get_current_user();
  $user_id = $current_user->ID;
  ?>
    <div class="col-md-3">
      <div class="meeek-inner-quick-link relative">
        <i class="far fa-envelope"></i>
        <a href="<?php echo get_the_permalink(); ?>?user-newsletter=table-view"><?php esc_html_e('My Newsletter Subscriptions', 'meeeksaas'); ?></a>
      </div>
    </div><?php
  if (isset($_GET['user-newsletter']) && $_GET['user-newsletter'] == 'table-view') {
    echo '<h3>'.esc_html__('My Newsletter Subscriptions', 'meeeksaas').'('.meeeksaas_count_subscriptions_by_user($user_id).')</h3>';
    echo meeeksaas_list_subscriptions_by_user($user_id);
  }
}
add_action( 'meeeksaas_after_account_quick_links', 'meeeksaas_my_subscription_list_Account' );


function meeeksaas_list_subscriptions_by_user($user_id) {
    global $wpdb;
    $table_name = $wpdb->prefix . 'meeeksaas_subscriptions';

    // Query to get all subscriptions for the given user_id
    $results = $wpdb->get_results(
        $wpdb->prepare(
            "SELECT * FROM $table_name WHERE user_id = %d",
            $user_id
        )
    );

    // Start building the HTML table
    $output = '<table>';
      $output .= '<thead>';
        $output .= '<tr>';
          $output .= '<th>'.esc_html__('Name', 'meeeksaas').'</th>';
          $output .= '<th>'.esc_html__('Email', 'meeeksaas').'</th>';
          $output .= '<th>'.esc_html__('Favorite Topic', 'meeeksaas').'</th>';
          $output .= '<th>'.esc_html__('Double Opt-In', 'meeeksaas').'</th>';
          $output .= '<th>'.esc_html__('Date', 'meeeksaas').'</th>';
        $output .= '</tr>';
      $output .= '</thead>';
    $output .= '<tbody>';

    // Check if results are not empty
    if (!empty($results)) {
        // Loop through the results and populate the table rows
        foreach ($results as $row) {
            $output .= '<tr>';
              $output .= '<td>' . esc_html($row->fullname) . '</td>';
              $output .= '<td>' . esc_html($row->email) . '</td>';
              $output .= '<td>' . esc_html($row->favorite_topic) . '</td>';
              $output .= '<td>' . (($row->double_opt_in=='1')?'yes':"no") . '</td>';
              $output .= '<td>' . esc_html($row->date) . '</td>';
            $output .= '</tr>';
        }
    } else {
        // If no results found, show a message
        $output .= '<tr>';
          $output .= '<td colspan="5">'.esc_html__('You have no subscribed users at this moment.', 'meeeksaas').'</td>';
        $output .= '</tr>';
    }

    $output .= '</tbody>';
    $output .= '</table>';

    // Add a button to download the CSV
    $output .= '<form method="post" class="mt-3 mb-3">';
    $output .= '<input type="hidden" name="user_id" value="' . esc_attr($user_id) . '">';
    $output .= '<button type="submit" name="download_csv" class="button">'.esc_html__('Download CSV', 'meeeksaas').'</button>';
    $output .= '</form>';

    return $output;
}


function meeeksaas_count_subscriptions_by_user($user_id) {
    global $wpdb;
    $table_name = $wpdb->prefix . 'meeeksaas_subscriptions';

    // Query to count the number of subscriptions for the given user_id
    $count = $wpdb->get_var(
        $wpdb->prepare(
            "SELECT COUNT(*) FROM $table_name WHERE user_id = %d",
            $user_id
        )
    );

    return $count;
}


function meeeksaas_download_csv() {
    if (isset($_POST['download_csv']) && isset($_POST['user_id'])) {
        global $wpdb;
        $user_id = intval($_POST['user_id']);
        $table_name = $wpdb->prefix . 'meeeksaas_subscriptions';

        // Query to get all subscriptions for the given user_id
        $results = $wpdb->get_results(
            $wpdb->prepare(
                "SELECT * FROM $table_name WHERE user_id = %d",
                $user_id
            )
        );

        // If there are results, create the CSV
        if (!empty($results)) {
            header('Content-Type: text/csv');
            header('Content-Disposition: attachment; filename="my_subscriptions_'.esc_attr($user_id).'.csv"');

            $output = fopen('php://output', 'w');
            // Add the header row
            fputcsv($output, array('Email', 'Double Opt-In', 'Date'));

            // Add the data rows
            foreach ($results as $row) {
                fputcsv($output, array($row->fullname, $row->email, $row->favorite_topic, $row->double_opt_in, $row->date));
            }

            fclose($output);
            exit;
        }
    }
}
add_action('init', 'meeeksaas_download_csv');