<?php
if ( ! defined( 'ABSPATH' ) ) {
    exit; // Exit if accessed directly.
}

/**
 * Add the new element on the Elements importable modal
 * 
 */
function meeeksaas_ticket_element(){ ?>
  <div class="list-inline col-md-6 mb-4">
    <div class="relative">
      <div class="list-inline-item align-middle">
        <div class="feature-icon bg-ticket">
          <i class="fas fa-ticket-alt"></i>
        </div>
      </div>
      <div class="list-inline-item align-middle">
        <h5 class="mb-0"><?php esc_html_e('Tickets', 'meeeksaas'); ?></h5>
        <p class="m-0"><?php esc_html_e('Add Event Tickets', 'meeeksaas'); ?></p>
      </div>
      <div class="list-inline-item align-middle float-end mt-2">
        <?php do_action('meeeksaas_element_add_button', 'ticket'); ?>
      </div>
      <?php do_action('meeeksaas_builder_allow_ticket'); ?>
    </div>
  </div><?php
}
add_action('meeeksaas_after_elements_list', 'meeeksaas_ticket_element');


/**
 * Map the new element on the import accepted elements array
 * 
 * @param $all_elements: array containing all the default elements
 */
function meeeksaas_add_ticket_el_to_els($all_elements){
  array_push($all_elements, 'ticket');
  
  return $all_elements;
}
add_filter('meeeksaas_available_elements', 'meeeksaas_add_ticket_el_to_els');

/**
 * Map the new element on the import accepted elements array
 * 
 * @param $all_elements: array containing all the default elements
 */
function meeeksaas_add_ticket_builder_fields($meeek_configuration){
  
    $item = $meeek_configuration;

    $title = ((array_key_exists('title', $item))?$item['title']:esc_html__('Button Text', 'meeeksaas'));
    $link = ((array_key_exists('link', $item))?$item['link']:'');
    $style_version = ((array_key_exists('style_version', $item))?$item['style_version'][0]:"off");
    $title_color = ((array_key_exists('title_color', $item))?$item['title_color']:"#000000");
    $event_name = ((array_key_exists('event_name', $item))?$item['event_name']:esc_html__('Cody Johnson - The Leather Tour', 'meeeksaas'));
    $event_cta_btn = ((array_key_exists('event_cta_btn', $item))?$item['event_cta_btn']:esc_html__('Tickets', 'meeeksaas'));
    $event_location = ((array_key_exists('event_location', $item))?$item['event_location']:esc_html__('London, ON', 'meeeksaas'));
    $event_date = ((array_key_exists('event_date', $item))?$item['event_date']:esc_html__('10 Aug 2024', 'meeeksaas'));
    $title_alignment = ((array_key_exists('title_alignment', $item))?$item['title_alignment']:'center');
    
    echo meeeksaas_input('text', 'title', $title, esc_html__('Heading', 'meeeksaas'), 'meeeksaas_title', true);
    echo meeeksaas_colorpicker('title_color', $title_color, esc_html__('Heading Color', 'meeeksaas'), 'title_color');
    echo meeeksaas_alignment_group('title_alignment', $title_alignment, esc_html__('Heading Alignment', 'meeeksaas'));
    echo meeeksaas_input('url', 'link', $link, esc_html__('Event Link', 'meeeksaas'), 'meeeksaas_link', true);
    echo meeeksaas_input('text', 'event_name', $event_name, esc_html__('Event Name', 'meeeksaas'), '', true);
    echo meeeksaas_input('text', 'event_location', $event_location, esc_html__('Event Location', 'meeeksaas'), '', true);
    echo meeeksaas_input('text', 'event_cta_btn', $event_cta_btn, esc_html__('CTA Button text', 'meeeksaas'), '', true);
    echo meeeksaas_input('text', 'event_date', $event_date, esc_html__('Event Date (E.g. 10 Aug 2025)', 'meeeksaas'), '', true);
    echo meeeksaas_checkbox('style_version', 'style_version', esc_html__('Light Style (If unchecked, the default style will be dark background and white text).', 'meeeksaas'), $style_version);

}
add_action('meeeksaas_ticket_builder_fields', 'meeeksaas_add_ticket_builder_fields');



function meeeksaas_ticket_frontend($type = '', $item = array()){
    if($type == 'ticket'){
      
      $style = '';
      $title = ((array_key_exists('bio_links_description', $item))?$item['bio_links_description']:'');
      $title_color = ((array_key_exists('title_color', $item['vcard']))?$item['vcard']['title_color']:"#000000");
      $title_alignment = ((array_key_exists('title_alignment', $item['vcard']))?$item['vcard']['title_alignment']:'center');
      $event_link = ((array_key_exists('link', $item['vcard']))?$item['vcard']['link']:'#');
      $event_name = ((array_key_exists('event_name', $item['vcard']))?$item['vcard']['event_name']:"Cody Johnson - The Leather Tour");
      $event_location = ((array_key_exists('event_location', $item['vcard']))?$item['vcard']['event_location']:"London, ON");
      $event_cta_btn = ((array_key_exists('event_cta_btn', $item['vcard']))?$item['vcard']['event_cta_btn']:"Tickets");
      $event_date = ((array_key_exists('event_date', $item['vcard']))?$item['vcard']['event_date']:"10 Aug 2024");
      $date = explode(" ", $event_date);
      $day = $date[0];
      $month = $date[1];
      $year = $date[2];
      $style_version = ((array_key_exists('style_version', $item['vcard']))?$item['vcard']['style_version'][0]:"meeeksaas-ticket-element-dark");
      $attr_target_new_tab =    ((array_key_exists('btn_target_new_tab', $item))?$item['btn_target_new_tab']:false);
      $target = '';
      if (is_array($attr_target_new_tab)) {
        if ($attr_target_new_tab[0] == 'on') {
          $target = 'target="_blank"';
        }
      }

      if ($style_version == 'on') {
        $style = '';
      } ?>

      <?php if($title){ ?>
        <h3 style="color:<?php echo esc_attr($title_color); ?>;" class="text-<?php echo esc_attr($title_alignment); ?>"><?php echo esc_html($title); ?></h3>
      <?php } ?>
      <div class="meeeksaas-ticket-element <?php echo esc_attr($style_version); ?>">
        <div class="meeeksaas-ticket-element-in">
          <div class="meeeksaas-ticket-date">
            <svg width="128" height="116" viewBox="0 0 128 116" fill="none" xmlns="http://www.w3.org/2000/svg" stroke="#000000" stroke-opacity="1"><path d="M1 8C1 4.134 4.13401 1 8 1H105.31C108.432 1 111.176 3.06684 112.038 6.06698L126.404 56.067C126.767 57.3301 126.767 58.6699 126.404 59.933L112.038 109.933C111.176 112.933 108.432 115 105.31 115H8.00001C4.13401 115 1 111.866 1 108V8Z" stroke="white" stroke-opacity="1" stroke-width="1"></path></svg>
            <div class="meeeksaas-ticket-date-inner">
              <span class="meeeksaas-date-month"><?php echo esc_html($month); ?></span>
              <span class="meeeksaas-date-day"><?php echo esc_html($day); ?></span>
              <span class="meeeksaas-date-year"><?php echo esc_html($year); ?></span>
            </div>
          </div>
          <div class="meeeksaas-ticket-content">
            <p><?php echo esc_html($event_name); ?></p>
            <div><?php echo esc_html($event_location); ?></div>
            <a href="<?php echo esc_url($event_link); ?>" <?php echo $target; ?>><?php echo esc_html($event_cta_btn); ?></a>
          </div>
          <div class="clearfix"></div>
        </div>
      </div>
      <?php
    }
}
add_action('meeeksaas_bio_item_bottom', 'meeeksaas_ticket_frontend', 10, 4);

