<?php
if ( ! defined( 'ABSPATH' ) ) {
    exit; // Exit if accessed directly.
}

/**
 * Add the new element on the Elements importable modal
 * 
 */
function meeeksaas_tiktok_element(){ ?>
    <div class="list-inline col-md-6 mb-4">
      <div class="relative">
        <div class="list-inline-item align-middle">
          <div class="feature-icon bg-tiktok">
            <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-tiktok" viewBox="0 0 16 16"> <path d="M9 0h1.98c.144.715.54 1.617 1.235 2.512C12.895 3.389 13.797 4 15 4v2c-1.753 0-3.07-.814-4-1.829V11a5 5 0 1 1-5-5v2a3 3 0 1 0 3 3V0Z"/> </svg>
          </div>
        </div>
        <div class="list-inline-item align-middle">
          <h5 class="mb-0"><?php esc_html_e('TikTok', 'meeeksaas'); ?></h5>
          <p class="m-0"><?php esc_html_e('Embed a TikTok Video.', 'meeeksaas'); ?></p>
        </div>
        <div class="list-inline-item align-middle float-end mt-2">
          <?php do_action('meeeksaas_element_add_button', 'tiktok'); ?>
        </div>
        <?php do_action('meeeksaas_builder_allow_tiktok'); ?>
      </div>
    </div><?php
}


/**
 * Map the new element on the import accepted elements array
 * 
 * @param $all_elements: array containing all the default elements
 */
function meeeksaas_add_tiktok_el_to_els($all_elements){
  array_push($all_elements, 'tiktok');
  
  return $all_elements;
}


/**
 * Map the new element on the import accepted elements array
 * 
 * @param $all_elements: array containing all the default elements
 */
function meeeksaas_add_tiktok_builder_fields($meeek_configuration){
  
    $item = $meeek_configuration;
    if ($item['btn_type'] == 'tiktok') {
        $title = ((array_key_exists('title', $item))?$item['title']:esc_html__('Button Text', 'meeeksaas'));
        $link = ((array_key_exists('link', $item))?$item['link']:'');
        $toggle_status = ((array_key_exists('toggle_status', $item))?$item['toggle_status'][0]:"off");
        $title_color = ((array_key_exists('title_color', $item))?$item['title_color']:"#000000");
        $title_alignment = ((array_key_exists('title_alignment', $item))?$item['title_alignment']:"left");

        echo meeeksaas_input('text', 'title', $title, esc_html__('Title', 'meeeksaas'), 'meeeksaas_title', true);
        echo meeeksaas_colorpicker('title_color', $title_color, esc_html__('Title Color', 'meeeksaas'), 'title_color');
        echo meeeksaas_alignment_group('title_alignment', $title_alignment, esc_html__('Title Alignment', 'meeeksaas'));
        echo meeeksaas_input('url', 'link', $link, esc_html__('Video Link', 'meeeksaas'), 'meeeksaas_link', true);
        echo meeeksaas_checkbox('toggle_status', 'toggle_status', esc_html__('Video Outside Toggle', 'meeeksaas'), $toggle_status);
    }
}


// tiktok video
function meeeksaas_tiktok_frontend($type = '', $item = array()){
    if($type == 'tiktok'){
        if (empty($link)) {
            $link = '';
        }
        $title = ((array_key_exists('bio_links_description', $item))?$item['bio_links_description']:esc_html__('Button Text', 'meeeksaas'));
        $link = ((array_key_exists('link', $item['vcard']))?$item['vcard']['link']:'');
        $toggle_status = ((array_key_exists('toggle_status', $item['vcard']))?$item['vcard']['toggle_status'][0]:"off");
        $title_color = ((array_key_exists('title_color', $item['vcard']))?$item['vcard']['title_color']:"#000000");
        $title_alignment = ((array_key_exists('title_alignment', $item['vcard']))?$item['vcard']['title_alignment']:"left");
    ?>
    <?php if($toggle_status == 'on'){ ?>
        <div class="meeek-toggle-off-holder">
            <h3 style="color:<?php echo esc_attr($title_color); ?>;" class="text-<?php echo esc_attr($title_alignment); ?>"><?php echo esc_html($title); ?></h3>
            <?php echo $GLOBALS['wp_embed']->run_shortcode( '[embed width="500"]'.esc_url($link).'[/embed]' ); ?>
        </div>
    <?php }else{ ?>
        <div class="meeek-bio-links-inner-dropdown meeek-accordion-card mb-3">
            <div class="meeek-accordion-card-inner">
                <div class="meeek-accordion-title" data-accordion-element-trigger>
                    <?php echo esc_html($title); ?>
                </div>
                <div data-accordion-element-content class="meeek-accordion-content">
                    <?php echo $GLOBALS['wp_embed']->run_shortcode( '[embed width="500"]'.esc_url($link).'[/embed]' ); ?>
                </div>
            </div>
        </div>
    <?php } ?>
    <?php
    }
}


// check if the el is restricted
if(!meeeksaas_is_element_restricted('tiktok')){
    // add the element on the elements modal
    add_action('meeeksaas_before_elements_list', 'meeeksaas_tiktok_element');
    // add the element on the elements list for plans
    add_filter('meeeksaas_available_elements', 'meeeksaas_add_tiktok_el_to_els');
    // add the element fields on builder
    add_action('meeeksaas_builder_element_fields', 'meeeksaas_add_tiktok_builder_fields');
    // frontend
    add_action('meeeksaas_bio_item_bottom', 'meeeksaas_tiktok_frontend', 10, 4);
}