<?php

/**
 * Add the new element on the Elements importable modal
 * s
 */
function meeeksaas_waitlist_element(){ ?>
  <div class="list-inline col-md-6 mb-4">
    <div class="relative">
      <div class="list-inline-item align-middle">
        <div class="feature-icon bg-waitlist">
          <i class="fas fa-clipboard-list"></i>
        </div>
      </div>
      <div class="list-inline-item align-middle">
        <h5 class="mb-0"><?php esc_html_e('Waiting List form', 'meeeksaas'); ?></h5>
        <p class="m-0"><?php esc_html_e('A Waiting List Form', 'meeeksaas'); ?></p>
      </div>
      <div class="list-inline-item align-middle float-end mt-2">
        <?php do_action('meeeksaas_element_add_button', 'waitlist'); ?>
      </div>
      <?php do_action('meeeksaas_builder_allow_waitlist'); ?>
    </div>
  </div><?php
}
add_action('meeeksaas_after_elements_list', 'meeeksaas_waitlist_element');


/**
 * Map the new element on the import accepted elements array
 * 
 * @param $all_elements: array containing all the default elements
 */
function meeeksaas_add_waitlist_el_to_els($all_elements){
  array_push($all_elements, 'waitlist');
  
  return $all_elements;
}
add_filter('meeeksaas_available_elements', 'meeeksaas_add_waitlist_el_to_els');

/**
 * Map the new element on the import accepted elements array
 * 
 * @param $all_elements: array containing all the default elements
 */
function meeeksaas_add_waitlist_builder_fields($meeek_configuration){
  if ($meeek_configuration['btn_type'] == 'waitlist') {
    $title = ((array_key_exists('title', $meeek_configuration))?$meeek_configuration['title']:esc_html__('Button Text', 'meeeksaas'));
    $subtitle = ((array_key_exists('subtitle', $meeek_configuration))?$meeek_configuration['subtitle']:esc_html__('Subtitle', 'meeeksaas'));
    $email_to = ((array_key_exists('email_to', $meeek_configuration))?$meeek_configuration['email_to']:esc_html__('Email Address', 'meeeksaas'));
    $toggle_status = ((array_key_exists('toggle_status', $meeek_configuration))?$meeek_configuration['toggle_status'][0]:'off');
    $style_version = ((array_key_exists('style_version', $meeek_configuration))?$meeek_configuration['style_version'][0]:'off');
  
    echo meeeksaas_input('text', 'title', $title, esc_html__('Button Text', 'meeeksaas'), 'meeeksaas_title', true);
    echo meeeksaas_input('text', 'subtitle', $subtitle, esc_html__('Subtitle', 'meeeksaas'), 'meeeksaas_subtitle', true);
    echo meeeksaas_input('text', 'email_to', $email_to, esc_html__('Email Address', 'meeeksaas'), 'email_to', true);
    echo meeeksaas_checkbox('toggle_status', 'toggle_status', esc_html__('Inline Form (No Link)', 'meeeksaas'), $toggle_status);
    echo meeeksaas_checkbox('style_version', 'style_version', esc_html__('Dark Style (If unchecked, the default style will be White background and black text).', 'meeeksaas'), $style_version);
  }
}
add_action('meeeksaas_builder_after_element_fields', 'meeeksaas_add_waitlist_builder_fields');



// Function to create the table
function meeeksaas_create_waitlist_subscriptions_table() {
    global $wpdb;
    $table_name = $wpdb->prefix . 'meeeksaas_subscriptions_waitlist'; // Create the table name with WP prefix
    $charset_collate = $wpdb->get_charset_collate();

    // SQL statement to create the table
    $sql = "CREATE TABLE $table_name (
      ID int(11) NOT NULL AUTO_INCREMENT,
      email varchar(200) NOT NULL,
      name varchar(200) NOT NULL,
      details varchar(200) NOT NULL,
      user_id int(10) NOT NULL,
      double_opt_in int(10) NOT NULL,
      date datetime DEFAULT CURRENT_TIMESTAMP NOT NULL,
      PRIMARY KEY  (ID)
    ) $charset_collate;";

    // Include the upgrade file and run the dbDelta function
    require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
    dbDelta($sql);
}

// Hook the table creation function to the after_setup_theme action
add_action('after_setup_theme', 'meeeksaas_create_waitlist_subscriptions_table');



if (!function_exists('meeeksaas_database_save_subscription_waitlist')) {
  function meeeksaas_database_save_subscription_waitlist($form_fields) {
    global $wpdb;

    $email = $form_fields['email'];
    $fullname = $form_fields['fullname'];
    $list_owner = $form_fields['list_owner'];
    $details = $form_fields['details'];
    
    $table_name = $wpdb->prefix . 'meeeksaas_subscriptions_waitlist';
    $user_id = $list_owner;

    // Check if a row exists for the given email and user_id
    $existing_row = $wpdb->get_row($wpdb->prepare(
        "SELECT * FROM $table_name WHERE email = %s AND user_id = %d",
        $email, $user_id
    ));

    if ($existing_row) {
      // Update the existing row
      $wpdb->update(
        $table_name,
        array(
          'double_opt_in' => 1, // Assuming we want to update double_opt_in field
          'date' => current_time('mysql') // Update the date to current time
        ),
        array('ID' => $existing_row->ID)
      );
    } else {
      // Insert a new row
      $wpdb->insert(
        $table_name,
        array(
          'email' => esc_html($email),
          'name' => esc_html($fullname),
          'details' => esc_html($details),
          'user_id' => esc_html($user_id),
          'double_opt_in' => 0, // Assuming default value for new records
        )
      );
    }
  }
}

function meeeksaas_subscription_waitlist_exists($email, $user_id) {
    global $wpdb;
    
    $table_name = $wpdb->prefix . 'meeeksaas_subscriptions_waitlist';

    // Check if a row exists for the given email and user_id
    $existing_row = $wpdb->get_var($wpdb->prepare(
        "SELECT COUNT(*) FROM $table_name WHERE email = %s AND user_id = %d",
        $email, $user_id
    ));

    if($existing_row == '1'){
      return true;
    }else{
      return false;
    }
}


function meeeksaas_waitlist_form_frontend(){ 
  $author_id = get_post_field('post_author', get_the_ID());

  if (isset($_GET['action']) && $_GET['action'] === 'waitlist-step-1' && isset($_GET['email'])) { ?>
    <div class="alert alert-warning alert-dismissible fade show" role="alert">
      <?php 
      if (meeeksaas_subscription_waitlist_exists($_GET['email'], $author_id)) {
        esc_html_e('You are now on the Waiting List for this author. If your submission is not yet confirmed, please check your inbox and confirm.', 'meeeksaas');
      }else{
        esc_html_e('Thank you for signing up for our Waiting List. To confirm your submission please check your email.', 'meeeksaas');
      } ?>
      <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="<?php esc_attr_e('Close', 'meeeksaas'); ?>"></button>
    </div>
    <?php
  }elseif (isset($_GET['action']) && $_GET['action'] === 'waitlist-confirmation' && isset($_GET['email'])) { ?>
    <div class="alert alert-success alert-dismissible fade show" role="alert">
      <?php esc_html_e('Your Waiting List submission is now confirmed! Thank you!', 'meeeksaas'); ?>
      <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="<?php esc_attr_e('Close', 'meeeksaas'); ?>"></button>
    </div>
    <?php
  }else{
    //...
  }
}
add_action('meeeksaas_before_bio_links_group', 'meeeksaas_waitlist_form_frontend');



function meeeksaas_waitlist_shortcode_form($params, $content) {
    extract( shortcode_atts( 
      array(
        'author_id'            => '',
        'style_mode'            => '',
        'title'            => '',
        'subtitle'            => '',
      ), $params ) );

    $terms_id = 'terms_'.uniqid();
    $contact_id = 'contact_'.uniqid();

    $title_text = __('Join My Waiting List', 'meeeksaas');
    if (!empty($title)) {
      $title_text = $title;
    }
    $subtitle_text = __('Sign up here for the waiting list.', 'meeeksaas');
    if (!empty($subtitle)) {
      $subtitle_text = $subtitle;
    }

    ob_start(); ?>

    <form method="GET" action="<?php the_permalink(); ?>" class="meeeksaas-waitlist-form <?php echo esc_attr($style_mode); ?>">
      <h3 class="text-center"><?php echo esc_html($title_text); ?></h3>
      <p class="text-center"><?php echo esc_html($subtitle_text); ?></p>

      <input name="list_owner_page_id" type="hidden"  value="<?php echo esc_attr(get_the_ID()); ?>"  placeholder="<?php esc_attr_e('page id', 'meeeksaas'); ?>" />
      <input name="list_owner" type="hidden" value="<?php echo esc_attr($author_id); ?>"  placeholder="<?php esc_attr_e('list owner', 'meeeksaas'); ?>" />
      <input name="action" type="hidden"  value="waitlist-step-1"  placeholder="<?php esc_attr_e('user id', 'meeeksaas'); ?>" />
      <input name="fullname" required type="text" class="mb-2" value="" placeholder="<?php esc_attr_e('Name *', 'meeeksaas'); ?>">
      <input name="email" required type="email" value="" placeholder="<?php esc_attr_e('Email *', 'meeeksaas'); ?>">
      <input name="details" required type="text" class="mb-3" value="" placeholder="<?php esc_attr_e('Details *', 'meeeksaas'); ?>">
      
      <p><input type="checkbox"  name="contact_consent" value="contact" id="<?php echo esc_attr($contact_id); ?>" required /> <label for="<?php echo esc_attr($contact_id); ?>"><?php esc_html_e('I agree to my contact details being shared with', 'meeeksaas'); ?> <?php the_title(); ?><?php esc_html_e(', who may contact me. *', 'meeeksaas'); ?></label></p>
      <input type="submit" value="<?php esc_attr_e('Enter now', 'meeeksaas'); ?>">
    </form>

    <?php
    return ob_get_clean();
}
add_shortcode('meeeksaas-waitlist-form', 'meeeksaas_waitlist_shortcode_form');




function meeeksaas_waitlist_check_for_url_parameter() {
    // email submit
    if (isset($_GET['action']) && $_GET['action'] === 'waitlist-step-1' && isset($_GET['email'])) {
        $list_owner = esc_attr($_GET['list_owner']);
        if (!meeeksaas_subscription_waitlist_exists($_GET['email'], $list_owner)) {
          meeeksaas_send_user_waitlist_email($_GET);
          meeeksaas_database_save_subscription_waitlist($_GET);
        }
    }

    // databse save
    if (isset($_GET['action']) && $_GET['action'] === 'waitlist-confirmation' && isset($_GET['email'])) {
      meeeksaas_database_save_subscription_waitlist($_GET);
      meeeksaas_send_author_waitlist_email($_GET);
    }
}
add_action('template_redirect', 'meeeksaas_waitlist_check_for_url_parameter');


// AUTHOR EMAIL + MAIL BODY
function meeeksaas_send_author_waitlist_email($form_fields) {

    $subject = get_bloginfo().esc_html__(': New Waiting List Submission', 'meeeksaas');
    $message = meeeksaas_author_waitlist_email_content($form_fields);
    $headers = array('Content-Type: text/html; charset=UTF-8');
    $current_user = wp_get_current_user();
    $to = $current_user->user_email;

    wp_mail($to, $subject, $message, $headers);
}


function meeeksaas_author_waitlist_email_content($form_fields) {
    ob_start();

    $email = $form_fields['email'];
    $name = $form_fields['fullname'];
    $details = $form_fields['details'];
    $list_owner = $form_fields['list_owner'];

    $body_style = 'font-family: Arial, sans-serif;';
    $table_style = 'color:#636363;border:1px solid #e5e5e5;vertical-align:middle;width:100%;font-family:\'Helvetica Neue\',Helvetica,Roboto,Arial,sans-serif';
    $th_td_style = 'color:#636363;border:1px solid #e5e5e5;vertical-align:middle;padding:12px;text-align:left;border-top-width:4px';
    ?>
    <html>
      <body style="<?php echo esc_attr($body_style); ?>">
        <h1><?php esc_html_e('You have a new user on your waiting list!', 'meeeksaas'); ?></h1>
        <table cellspacing="0" cellpadding="6" border="1" style="<?php echo esc_attr($table_style); ?>" width="100%">
          <tr>
            <th scope="row" style="<?php echo esc_attr($th_td_style); ?>" align="left"><?php esc_html_e('Name:', 'meeeksaas'); ?></th>
            <td style="<?php echo esc_attr($th_td_style); ?>" align="left"><?php echo esc_html($name); ?></td>
          </tr>
          <tr>
            <th scope="row" style="<?php echo esc_attr($th_td_style); ?>" align="left"><?php esc_html_e('Email:', 'meeeksaas'); ?></th>
            <td style="<?php echo esc_attr($th_td_style); ?>" align="left"><?php echo esc_html($email); ?></td>
          </tr>
          <tr>
            <th scope="row" style="<?php echo esc_attr($th_td_style); ?>" align="left"><?php esc_html_e('Details:', 'meeeksaas'); ?></th>
            <td style="<?php echo esc_attr($th_td_style); ?>" align="left"><?php echo esc_html($details); ?></td>
          </tr>
        </table>
        <p><?php esc_html_e('If you received this email by mistake simply ignore this message.', 'meeeksaas'); ?></p>
      </body>
    </html>
    <?php
    return ob_get_clean();
}


// USER EMAIL + MAIL BODY
function meeeksaas_send_user_waitlist_email($form_fields) {
  $email = $form_fields['email'];
  $subject = get_bloginfo().esc_html__(': Waiting List Confirmation', 'meeeksaas');
  $message = meeeksaas_user_waitlist_email_content($form_fields);
  $headers = array('Content-Type: text/html; charset=UTF-8');
  $to = $email;
  wp_mail($to, $subject, $message, $headers);
}


function meeeksaas_user_waitlist_email_content($form_fields) {
  ob_start();

  $email = $form_fields['email'];
  $name = $form_fields['fullname'];
  $details = $form_fields['details'];
  $list_owner = $form_fields['list_owner'];
  $page_id = $form_fields['list_owner_page_id'];

  $confirm_url = add_query_arg( array(
      'list_owner' => esc_attr($list_owner),
      'action' => 'waitlist-confirmation',
      'email' => esc_attr($email),
      'fullname' => esc_attr($name),
      'details' => esc_attr($details),
  ), get_the_permalink($page_id) );

  $body_style = 'font-family: Arial, sans-serif;';
  $btn_style = 'display: inline-block; border: none; border-radius: 3px; color: rgb(255, 255, 255); padding: 10px 25px;text-decoration: none; background: rgb(0, 166, 249); color: rgb(255, 255, 255); font-family: Arial, sans-serif; font-size: 16px; font-weight: normal; line-height: 120%; text-transform: none; margin: 0px;';

  ?>
  <html>
  <body style="<?php echo esc_attr($body_style); ?>">
      <h1><?php esc_html_e('Please confirm your Waiting List submission!', 'meeeksaas'); ?></h1>
      <p><?php esc_html_e('Thank you for signing up for our waitlist. To confirm your submission to', 'meeeksaas'); ?> <a href="<?php echo get_the_permalink($page_id); ?>" target="_blank"><?php echo get_the_title($page_id); ?></a><?php esc_html_e(', please click on the button below:', 'meeeksaas'); ?></p>
      <a href="<?php echo esc_url($confirm_url); ?>" target="_blank" style="<?php echo esc_attr($btn_style); ?>"><b><?php esc_html_e('Confirm Waiting List Submission', 'meeeksaas'); ?></b></a>
      <p><?php esc_html_e('If you received this email by mistake simply ignore this message.', 'meeeksaas'); ?></p>
  </body>
  </html>
  <?php
  return ob_get_clean();
}


// Element Embed
function meeeksaas_waitlist_frontend($item = '', $version = ''){
  $type = ((array_key_exists('btn_type', $item))?$item['btn_type']:"waitlist");
  if($type == 'waitlist'){

    $style_version = ((array_key_exists('style_version', $item))?$item['style_version'][0]:"off");
    $toggle_status = ((array_key_exists('toggle_status', $item))?$item['toggle_status'][0]:"off");
    $title = ((array_key_exists('title', $item))?$item['title']:"");
    $subtitle = ((array_key_exists('subtitle', $item))?$item['subtitle']:"");
    $style = 'meeeksaas-waitlist-light-texts';
    if ($style_version == 'off') {
      $style = 'meeeksaas-waitlist-dark-texts';
    }

    $author_id = get_post_field('post_author', get_the_ID()); ?>
    <?php if($toggle_status == 'off'){ ?>
      <div class="meeeksaas-single-link-holder meeeksaas-single-link--<?php echo esc_attr($version); ?> meeeksaas-el--waitlist">
        <div class="meeeksaas-el-inner--waitlist">
          <i class="fas fa-clipboard-list  fa-beat-fade"></i> <?php echo esc_html($title); ?>
          <a aria-label="<?php echo esc_attr($title); ?>" target="_blank" data-bs-toggle="modal" data-bs-target="#meeeksaas_waitlist_modal" class="meeeksaas-waitlist-link-btn" href="#"></a>
        </div>
      </div>
      <!-- modal -->
      <div class="modal fade text-center meeeksaas-modal-waitlist" id="meeeksaas_waitlist_modal" tabindex="-1" aria-labelledby="meeeksaas_waitlist_modalLabel" aria-hidden="true">
        <div class="modal-dialog modal-dialog-centered modal-dialog-scrollable">
          <div class="modal-content">
            <div class="modal-header p-4">
              <h5 class="modal-title"><?php echo esc_html__('Subscribe to ', 'meeeksaas').get_the_title().esc_html__(' Waitlist', 'meeeksaas'); ?></h5>
              <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="<?php esc_attr_e('Close', 'meeeksaas'); ?>"></button>
            </div>
            <div class="modal-body p-4">
              <?php echo do_shortcode('[meeeksaas-waitlist-form author_id="'.esc_attr($author_id).'" style_mode="meeeksaas-waitlist-dark-texts" title="'.esc_attr($title).'" subtitle="'.esc_attr($subtitle).'"]'); ?>
            </div>
          </div>
        </div>
      </div>
    <?php }else{ 
      echo do_shortcode('[meeeksaas-waitlist-form author_id="'.esc_attr($author_id).'" style_mode="'.esc_attr($style).'" title="'.esc_attr($title).'" subtitle="'.esc_attr($subtitle).'"]');
    } 
  }
}
add_action('meeeksaas_bio_link_element', 'meeeksaas_waitlist_frontend', 10, 2);



/**
* WooCommerce accounts: My Dashboard quicklinks
*/
function meeeksaas_my_waitlist_list_Account() { 
  
  $link = add_query_arg( array(
    'user-waitlist' => 'table-view',
  ), get_the_permalink() );
  ?>
  <div class="col-md-3">
    <div class="meeek-inner-quick-link relative">
      <i class="far fa-list-alt"></i>
      <a href="<?php echo esc_url($link); ?>"><?php esc_html_e('My Waitlist Subscriptions', 'meeeksaas'); ?></a>
    </div>
  </div><?php
       
  $current_user = wp_get_current_user();
  $user_id = $current_user->ID;

  if (isset($_GET['user-waitlist']) && $_GET['user-waitlist'] == 'table-view') {
    echo '<h3>'.esc_html__('My Wailist Subscriptions', 'meeeksaas').'('.meeeksaas_count_waitlist_by_user($user_id).')</h3>';
    echo meeeksaas_list_waitlist_by_user($user_id);
  }
}
add_action( 'meeeksaas_after_account_quick_links', 'meeeksaas_my_waitlist_list_Account' );


function meeeksaas_list_waitlist_by_user($user_id) {

    global $wpdb;
    $table_name = $wpdb->prefix . 'meeeksaas_subscriptions_waitlist';

    // Query to get all subscriptions for the given user_id
    $results = $wpdb->get_results(
        $wpdb->prepare(
            "SELECT * FROM $table_name WHERE user_id = %d",
            $user_id
        )
    );

    // Start building the HTML table
    $output = '<table>';
      $output .= '<thead>';
        $output .= '<tr>';
          $output .= '<th>'.esc_html__('Email', 'meeeksaas').'</th>';
          $output .= '<th>'.esc_html__('Name', 'meeeksaas').'</th>';
          $output .= '<th>'.esc_html__('Details', 'meeeksaas').'</th>';
          $output .= '<th>'.esc_html__('Double Opt-In', 'meeeksaas').'</th>';
          $output .= '<th>'.esc_html__('Date', 'meeeksaas').'</th>';
        $output .= '</tr>';
      $output .= '</thead>';
    $output .= '<tbody>';
      if (!empty($results)) {
        foreach ($results as $row) {
          $output .= '<tr>';
            $output .= '<td>' . esc_html($row->email) . '</td>';
            $output .= '<td>' . esc_html($row->name) . '</td>';
            $output .= '<td>' . esc_html($row->details) . '</td>';
            $output .= '<td>' . (($row->double_opt_in=='1')?'yes':"no") . '</td>';
            $output .= '<td>' . esc_html($row->date) . '</td>';
          $output .= '</tr>';
        }
      } else {
        $output .= '<tr>';
          $output .= '<td colspan="5">'.esc_html__('You have no users on your waitlist at this moment.', 'meeeksaas').'</td>';
        $output .= '</tr>';
      }
    $output .= '</tbody>';
    $output .= '</table>';

    $output .= '<form method="post" class="mt-3 mb-3">';
      $output .= '<input type="hidden" name="user_id" value="' . esc_attr($user_id) . '">';
      $output .= '<button type="submit" name="waitlist_download_csv" class="button">'.esc_html__('Download CSV', 'meeeksaas').'</button>';
    $output .= '</form>';

    return $output;
}


function meeeksaas_count_waitlist_by_user($user_id) {

    global $wpdb;
    $table_name = $wpdb->prefix . 'meeeksaas_subscriptions_waitlist';
    $count = $wpdb->get_var(
        $wpdb->prepare(
            "SELECT COUNT(*) FROM $table_name WHERE user_id = %d",
            $user_id
        )
    );

    return $count;
}


function meeeksaas_waitlist_download_csv() {
    if (isset($_POST['waitlist_download_csv']) && isset($_POST['user_id'])) {
        global $wpdb;
        $user_id = intval($_POST['user_id']);
        $table_name = $wpdb->prefix . 'meeeksaas_subscriptions_waitlist';

        // Query to get all subscriptions for the given user_id
        $results = $wpdb->get_results(
            $wpdb->prepare(
                "SELECT * FROM $table_name WHERE user_id = %d",
                $user_id
            )
        );

        // If there are results, create the CSV
        if (!empty($results)) {
            header('Content-Type: text/csv');
            header('Content-Disposition: attachment; filename="my_waitlist_'.esc_attr($user_id).'.csv"');

            $output = fopen('php://output', 'w');
            // Add the header row
            fputcsv($output, array('Email', 'Name', 'Details', 'Double Opt-In', 'Date'));

            // Add the data rows
            foreach ($results as $row) {
                fputcsv($output, array($row->email, $row->name, $row->details, $row->double_opt_in, $row->date));
            }

            fclose($output);
            exit;
        }
    }
}
add_action('init', 'meeeksaas_waitlist_download_csv');